#!/bin/sh

tce=$(cat /etc/sysconfig/backup_device)
lang=$(cat /mnt/$tce/language/default)

[ "$lang" == "" ] && lang=ru

source /mnt/$tce/language/lang_$lang

site=$(cat /opt/siteupdate)
slog=/tmp/update.log
flog=/home/tc/log/updatelog.txt
updfile=/home/tc/update.txt
tmpdir=/home/tc/tmp
utmp=update.txt
state=$(cat /tmp/update.state)
if [ "$state" == "checkupdate" ] || [ "$state" == "runupdate" ]; then
    exit 0 
fi

# 1. clear catalog
sudo rm -f /home/tc/tmp/*.gz
sudo rm -f /home/tc/tmp/*.txt
# 2. get whatnews & update.txt
echo "checkupdate" >/tmp/update.state
echo "$tab2_c1 ...<br>" > $slog
echo "$(date)<br>">> $slog
echo "$(date)"> $flog
ping -c 3 -W 1 yandex.ru
if [ ! $? -eq 0 ]; then
    echo "$tab2_c2<br>" >>$slog
    echo "No internet connection">>$flog
    echo "error" >/tmp/update.state
    exit 0
fi
sudo /usr/local/bin/wget $site/$utmp 2>&1 -O $tmpdir/$utmp | sed "s/$/<br>/" | tee -a $slog
if [ ! -s $tmpdir/$utmp ]; then
    echo "File update.txt not found">>$flog
    echo "File update.txt not found<br>">>$slog
    sleep 2
    echo "File update.txt not found<br>">$slog
    echo "error" >/tmp/update.state
    exit
fi

if [ "$lang" == "ru" ]; then
    wf="whatnews.txt"
else
    wf="whatnews_en.txt"
fi

sudo /usr/local/bin/wget $site/$wf -O $tmpdir/whatnews.txt | sed "s/$/<br>/" | tee -a $slog
if [ -s $tmpdir/whatnews.txt ]; then
    sudo /bin/cp -rf $tmpdir/whatnews.txt /opt
else 
    echo "Wget error whatnews.txt">>$flog
    echo "error" >/tmp/update.state
fi
# 3. cut updates
curupdate=""
if [ -f /opt/version ]; then
    curupdate=$(/bin/cat /opt/version)
    if [ -n "$curupdate" ]; then
	sed -n '/'"$curupdate"'/,$p' $tmpdir/$utmp -i $tmpdir/$utmp
	sed '1d' -i $tmpdir/$utmp
	echo "cut updates <br>" >> $slog
	echo "cut updates" >> $flog
    else
    # or full update
	curupdate=""
    fi
fi

if [ -s $tmpdir/$utmp ]; then
    nums=$(sed -n '$=' $tmpdir/$utmp)
    echo "Num updates: $nums<br>" >> $flog
    echo "$tab2_c3: $nums<br>" >> $slog
    sleep 2
    echo "$tab2_c3: $nums<br>" > $slog
    echo "checkfinish" >/tmp/update.state
    sleep 1
else
    echo "No new updates." >> $flog
    echo "$tab2_c4<br>">>$slog
    sleep 2
    echo "$tab2_c4<br>">$slog
fi
echo "" >/tmp/update.state
