#!/bin/sh

tce=$(cat /etc/sysconfig/backup_device)
lang=$(cat /mnt/$tce/language/default)

[ "$lang" == "" ] && lang=ru

source /mnt/$tce/language/lang_$lang

if [ -n "$(cat /tmp/update.state)" ]; then
    exit 0
fi

flog=/home/tc/log/updatelog.txt
slog=/tmp/update.log
updir=/home/tc/tmp/update
tmpdir=/home/tc/tmp
utmp=update.txt
if [ -n "$(cat /tmp/update.state)" ]; then
    exit 0
fi
echo "runupdate" > /tmp/update.state
    
echo "$tab2_r1 ...<br>" > $slog
echo "Run update..." >> $flog
# 1. check internet connection
sudo /bin/rm -f $tmpdir/*.gz
sudo /bin/rm -f $tmpdir/*.tmp
echo "$(/bin/date)<br>" >> $slog
/bin/ping -c 3 -W 1 yandex.ru
if [ ! $? -eq 0 ]; then
    echo "$tab2_c2<br>" >>$slog
    echo "No internet connection" >> $flog
    exit 0
fi

# 4. get file & update
if [ ! -d $tmpdir/update ]; then
    /bin/mkdir $tmpdir/update
fi

while read line
do
    fil=$(echo "$line" | /usr/bin/cut -d ' ' -f1 | sed "s| ||g")
    dat=$(echo "$line" | /usr/bin/cut -d ' ' -f2)
    ver=$(echo "$line" | /usr/bin/cut -d ' ' -f3 | sed "s|\r||g")
    url=$(echo "$line" | /usr/bin/cut -d ' ' -f4 | sed "s|\r||g")
    if [ -z "$fil" ]; then
        break
    fi
    fname=$fil
# 4.1 download
	echo "$tab2_r2: $fil<br>" >> $slog
	echo "Download file: $fil" >> $flog
	/usr/local/bin/wget "http://copy.com/$url/$fil" -O $tmpdir/$fil
	if [ $? -eq 0 ]; then
	    echo "$tab2_r3: $fname<br>" >> $slog
	    echo "Downloaded OK." >> $flog
	else
	    echo "$tab2_r4:$fname<br>" >> $slog
	    echo "Skip or Error!" >> $flog
	fi
# 4.2. untar
    	echo "$tab2_r5: $fname<br>" >> $slog
    	echo "Unpack: $fil" >> $flog
	state=$(sudo /bin/tar xzf $tmpdir/$fil -C $updir 2>&1)

	if [ ! $state ]; then
	    echo "$tab2_r6<br>" >> $slog
	    echo "Unpack complete." >> $flog
	    scr=$(echo $fil | sed 's/\..*//')
# 4.3. exec
	    if [ -f $updir/${scr}.sh ]; then
	    /bin/chmod +x $updir/${scr}.sh
	    sudo $updir/${scr}.sh
	    sudo /bin/rm -f $updir/${scr}.sh
	    fi
	sudo /bin/cp -rf $updir/* /
    	echo "$tab2_r7<br>" >> $slog
    	echo "Copying complete." >> $flog
    	echo "$ver" > /opt/version
    else
	echo "$tab2_r8<br>" >> $slog
	echo "Unpack ERROR!" >> $flog
    fi
# 4.4. clean
	sudo /bin/rm -rf $tmpdir/update/*
	sudo /bin/rm -rf $tmpdir/$fil

	# next
#    fi
done < $tmpdir/$utmp # list ascending

sudo rm -f $tmpdir/$utmp
echo "Update complete." >> $flog
echo "$tab2_r9<br>">> $slog
echo "updatefinish" > /tmp/update.state
sleep 5
echo "" > /tmp/update.state
echo "$tab2_r9<br>"> $slog
