#!/bin/busybox ash
# Original script by Robert Shingledecker
# (c) Robert Shingledecker 2003-2012
. /etc/init.d/tc-functions
useBusybox
CMDLINE="$(cat /proc/cmdline)"

MYDATA=mydata
[ -r /etc/sysconfig/mydata ] && read MYDATA < /etc/sysconfig/mydata
# Functions --

# Main  --
unset BACKUP PROMPT RESTORE SAFE DRYRUN VERBOSE

BACKUP=TRUE

#Get the TARGET name from argument 1 or /etc/sysconfig/backup_device
if [ -z $1 ]; then
  TARGET="$(cat /etc/sysconfig/backup_device 2>/dev/null)"
else
  TARGET="$1"
fi

if [ -z "$TARGET" ]; then
  # Last chance to default to persistent TCE directory if exists
  TCEDIR="$(readlink /etc/sysconfig/tcedir)"
  if [ "$TCEDIR" == "/tmp/tce" ]; then
    echo "Invalid or not found $TARGET" > /tmp/backup_status
    wrapup
  else
    TARGET="${TCEDIR#/mnt/}"
  fi
fi

TARGET="${TARGET#/dev/}"
DEVICE="${TARGET%%/*}"
FULLPATH="${TARGET#$DEVICE/}"
[ "$FULLPATH" = "$DEVICE" ] && FULLPATH=""

find_mountpoint $DEVICE

if [ "$BACKUP" ] ; then
  sed -i /^$/d /opt/.filetool.lst
    echo -n "Backing up files to $MOUNTPOINT/$FULLPATH/${MYDATA}.tar"
    [ -f /tmp/backup_status ] && sudo /bin/rm -f /tmp/backup_status
    /usr/bin/sudo /bin/tar -C / -T /opt/.filetool.lst -X /opt/.xfiletool.lst  -cf "$MOUNTPOINT/"$FULLPATH"/${MYDATA}.tar"  2>/tmp/backup_status &
    rotdash $!
    sync
#    [ -s /tmp/backup_status ] && /usr/bin/sudo sed -i '/socket ignored/d' /tmp/backup_status 2>/dev/null
#    [ -s /tmp/backup_status ] && exit 1
    /usr/bin/sudo /bin/touch /tmp/backup_done
  echo "Done."
#  clean_up 0
fi
