#!/bin/sh

varfile=/opt/var.sh

v_write(){
    sed -e "s/^$1=.*/$1=$2/" $varfile > /tmp/temp.$$
    /bin/mv -f /tmp/temp.$$ $varfile
}
cp -f /home/libsoxr.so.0 /lib
#cp -f /home/dsdplay /usr/lms/Bin/i386-linux

cp -f /home/custom-convert.conf /usr/lms/
ln -s /usr/local /root/alsadir

ln -s /home/tc/sq/writeloop /usr/bin/writeloop
ln -s /home/tc/sq/catloop /usr/bin/catloop
ln -s /home/tc/sq/playhrt /usr/bin/playhrt
ln -s /usr/local/bin/aplay /usr/bin/aplay

source /opt/var.sh
# Tiny Squeeze 1.2 (c) 05/12/2015
# 0. Optimize timer
echo $hpetfq > /proc/sys/dev/hpet/max-user-freq
echo $tscfq > /sys/class/rtc/rtc0/max_user_freq

ncpu=$(cat /proc/cpuinfo | grep ^processor | wc -l)
echo $ncpu >/tmp/numcpu

boot=$(cat /etc/sysconfig/backup_device | sed "s|\/tce||")
fname="/mnt/$boot/boot/syslinux/syslinux.cfg"

a=$(cat $fname | grep "isolcpus")
case $ncpu in
1)  if [ $audiocpu -gt 2 ]; then
	audiocpu=1
	$(v_write audiocpu $audiocpu)
    fi
    sqcpu=0x01
    lmscpu=0x01
    sqoutcpu=0x01
    if [ -n "$a" ]; then
	sed -e "s|isolcpus=.*||1" $fname > /tmp/temp.$$ && /bin/mv -f /tmp/temp.$$ $fname
    fi
;;
2)  if [ $audiocpu -gt 2 ]; then
	audiocpu=2
	$(v_write audiocpu $audiocpu)
    fi
    sqlst="0x02 0x03"
    if ! [[ $sqlst =~ .*$sqcpu.* ]]; then
	sqoutcpu=0x02
	$(v_write sqoutcpu $sqoutcpu)
    fi
    
    if [ -z "$a" ]; then
	sed -e "s|^.*tinyrt\.gz|& isolcpus=1|1" $fname > /tmp/temp.$$ && /bin/mv -f /tmp/temp.$$ $fname
    else
	if [ -z $(echo "$a" | grep "isolcpus=1") ]; then
	    sed -e "s|isolcpus=.* |isolcpus=1 |1" $fname > /tmp/temp.$$ && /bin/mv -f /tmp/temp.$$ $fname
	fi
    fi
;;
*)
    if [ -z "$a" ]; then
	sed -e "s|^.*tinyrt\.gz|& isolcpus=2,3|1" $fname > /tmp/temp.$$ && /bin/mv -f /tmp/temp.$$ $fname
    else
	if [ -z $(echo "$a" | grep "isolcpus=2") ]; then
	    sed -e "s|isolcpus=.* |isolcpus=2,3 |1" $fname > /tmp/temp.$$ && /bin/mv -f /tmp/temp.$$ $fname
	fi
    fi
;;
esac

# cpu mask
#3 - 1,2
#4 - 2
#5 - 1,3
#6 - 2,3
#7 - 1,2,3
#8 - 4
if [ $ncpu -eq 1 ] || [ $role == server ]; then 
    cpu2=""
    cpubr=""
    cpulms=""
else 
    if [ -n "$sqcpu" ] && [ "$sqcpu" != "0x0" ]; then
	cpu2="/usr/bin/taskset $sqcpu"
    else
	if [ $ncpu -eq 2 ]; then
	    cpu2="/usr/bin/taskset 0x02" #2
	else
	    cpu2="/usr/bin/taskset 0x08" #4
	fi
    fi
    cpubr=""
    if [ -n "$brutecpu" ] && [ "$brutecpu" != "0x0" ]; then
	cpubr="/usr/bin/taskset $brutecpu"
    fi
    cpulms=""
    if [ -n "$lmscpu" ] && [ "$lmscpu" != "0x0" ]; then
	cpulms="/usr/bin/taskset $lmscpu"
    fi
    
fi

# 1. optimize irq priority, network, scheduler

sysctl -p /etc/sysctl.conf & >/dev/null
echo 30 > /proc/sys/vm/stat_interval

if [ $lowcpu == yes ]; then
    /usr/local/bin/cpufreq-set -c 0 -f $cpufreq -r
    /usr/local/bin/cpufreq-set -c 1 -f $cpufreq -r
fi

/opt/cfq.sh $cfqset

# 2. mount local disk
/opt/bmount.sh
  
if [ $dhcp == no ]; then
    /opt/eth0.sh
else
    [ -n "$ipdns1" ] && echo "nameserver $ipdns1" > /etc/resolv.conf
    [ -n "$ipdns2" ] && echo "nameserver $ipdns2" >> /etc/resolv.conf
    /usr/bin/taskset -p 0x01 $(pidof udhcpc)
    /usr/bin/taskset -p 0x01 $(pidof udevd)
fi
ifconfig eth0 txqueuelen 10000

# CPU IRQ affinity
[ $ncpu -gt 1 ] && /opt/irq.sh $ncpu
if [ $autoirq == yes ]; then
    /home/tc/rtirq_.sh start & >/dev/null
else
    # IRQ priority
    /opt/irqprio.sh
fi

# 3. acpi power off 
/usr/local/etc/init.d/acpid start & >/dev/null
# 4. start ssh-server 
[ $sshserv == yes ] && /etc/init.d/dropbear start & >/dev/null

# 5. mount netdisk
    /opt/netdisk.sh
if [ $role == full ] || [ $role == server ]; then
    lf=""
    lmsprio=""
    if [ $role == full ]; then 
	lf="--localfile"  # read localfile
#    else
#	lmsprio="--priority -10"
    fi
    mysq=""
    [ $mysqueezebox == no ] && mysq="--nomysqueezebox"
    supnp=""
    [ $lmsupnp = no ] && supnp="--noupnp"
    
    [ $srvconvert == yes ] && rm -f /usr/lms/convert.conf

    chmod -R 777 /usr/lms
    chown -R root /usr/lms
    $cpulms /usr/lms/slimserver.pl --user root --daemon --novideo --charset utf8 $lf $mysq $supnp $lmsprio --nodebuglog
fi
# 6. cover art server & web-interface
    /usr/local/sbin/lighttpd -f /home/tc/lighttpd.conf & >/dev/null
# 7. alsa tweak 
if [ $role == full ] || [ $role == player ]; then

    if [ -n $nrpacks ]; then
        /sbin/modprobe -r snd-usb-audio
        if [ $audiodev == usb ]; then
    	    /sbin/modprobe snd-usb-audio nrpacks=$nrpacks
    	fi
    	/sbin/modprobe snd-aloop
    fi
    /home/tc/sq/hw_params | grep "Formats:\|rates:" >/tmp/formats
#    amixer -c 0 set Master playback 100% unmute #asus 701

# 8. start squeezeslave

    num1=aa
    sdev=aa
    num2=0
    if [ $audiodev == pci ]; then
	num2=1
        pcinum=$(lspci -v | sed -e '/./{H;$!d;}' -e 'x;/snd-/!d;'| sed -n 2p | awk '{print $1}') 
        if [ -n "$pcinum" ]; then
	    setpci -v -d *:* latency_timer=b0
	    setpci -v -s $pcinum latency_timer=ff
	fi
    fi

    cat /proc/asound/cards |grep "]:"| while read line; do
	fl=$(echo $line | grep "ICE1724\|AV200")
	if [ -z "$fl" -a $audiodev == usb ] || [ -n "$fl" -a $audiodev == pci ]; then
	    number=${line:0:1}
	    sdev=${line#*]: }
	    echo "$number,$num2" >/opt/alsa/devnum
	    echo $sdev >/opt/alsa/devname
	    break
	fi
    done

#change .asoundrc
    num1=$(cat /opt/alsa/devnum)
    card=${num1:0:1}

    cat /home/tc/.asoundrc | sed "s/\tpcm \"hw.*/\tpcm \"hw:$num1\"/;s/card.*/card $card/" >/tmp/temp.1
    /bin/mv -f /tmp/temp.1 /home/tc/.asoundrc

    echo "Starting Squeezeslave."

if [ $sqlog == no ]; then
    slog=""
else
    slog="-f /home/tc/log/sqlite.log -d all=debug"
fi

if [ -z "$maxrate" ]; then
    rates=$(cat /tmp/formats | grep rate | head -1)
    rates=${rates#*:}
    maxrate=${rates##* }
    $(v_write maxrate $maxrate)
fi

usample=""
srate=""

if [ $limitrate == yes ]; then
    if [ $fixrate == yes ]; then
	srate="-r $maxrate-$maxrate"
    else
	srate="-r $maxrate"
    fi
#    usample="-R vLs:18:3"
    usample="-R X"
fi

if [ $sqpipe == standart ]; then
    if [ $audiodev == usb ]; then
	spk=front
    else
	spk=iec958
    fi
    [ $brutefir == yes ] && spk=hw:Loopback,0,0
    $cpu2 $sqzlite -o $spk -n $squeezeplayername -a $sqalsa -C 2 -b $sqbuffer:$sqoutbuffer $srate $usample $slog -p $sqprio -z >/dev/null
    sleep 1.5
    a=$(/usr/bin/ps2 -C squeezelite -L | tail -2 | head -1 | awk '{print $2}')
    if [ -n "$a" ]; then
	/usr/bin/renice -10 $a
	/usr/bin/taskset -p $sqoutcpu $a
    fi
    if [ $brutefir == yes ]; then
	brconfig=/home/tc/.brutefir_config
	cat $brconfig | sed "/left_out/,/}/s|{ device:.*\"|{ device: \"hw:$num1\"|1" >/tmp/temp.1
	/bin/mv -f /tmp/temp.1 $brconfig
	sleep 2 
	$cpubr /usr/lib/brutefir/brutefir.real -nodefault $brconfig -daemon
    fi
else
    if [ -z "$format" ]; then
        formats=$(cat /tmp/formats | grep Format | head -1)
        formats=${formats#*:}
        format=${formats##* }
        $(v_write format $format)
    fi

    formatbit=32
    [ $format == S24_3LE ] && formatbit=24
    [ $format == S16_LE ] && formatbit=16

    cat /home/tc/sq/pipe_$sqpipe | sed "s/\#device/$num1/;s/\#format/$format/" >/tmp/temp.1
    /bin/mv -f /tmp/temp.1 /home/tc/sq/pipe3

    if [ -n "$sqmacaddr" ]; then
	$cpu2 $sqzlite -o - -n $squeezeplayername -m $sqmacaddr -a $formatbit -b $sqbuffer:$sqoutbuffer $srate $usample $slog -j /home/tc/sq/pipe3 -z
    else
#    $cpu2 $sqzlite -o front -n $squeezeplayername -a $sqalsa -b $sqbuffer:$sqoutbuffer -f /home/tc/log/sqlite.log -p $sqprio -z >/dev/null
	$cpu2 $sqzlite -o - -n $squeezeplayername -a $formatbit -b $sqbuffer:$sqoutbuffer $srate $usample $slog -j /home/tc/sq/pipe3 -z
    fi
    sleep 2
    ap=$(pidof aplay)
    ah=$(pidof playhrt)
    if [ -n "$ap" ]; then
	/usr/bin/renice -10 $ap
	/usr/bin/chrt -p -f 90 $ap
    fi
    if [ -n "$ah" ]; then
	/usr/bin/renice -10 $ah
	/usr/bin/chrt -p -f 90 $ah
    fi
fi

fi #role=full || player


#13. start samba
if [ $samba == yes ]; then
    echo "Starting Samba."
    /usr/local/etc/init.d/samba start &
fi
