#!/bin/sh
#  mount network folder 
boot=$(cat /etc/sysconfig/backup_device)
shar="/mnt/$boot/shares.txt"
shares=$(cat $shar | grep "^\[" | sed "s/\[//g;s/\]//g")

get_ini(){
    while read section; do
	if [ "$section" = '['$1']' ]; then
	    IFS='='
	    while read key value; do
		if [ $key = $2 ]; then
		    echo "$value"
		    exit 1
		fi
	    done
	fi
	#echo "$section"
    done < $shar
}


for x in $shares
do
    fs=$(get_ini $x fs)
    server=$(get_ini $x server)
    share=$(get_ini $x share)
    dir1=$(get_ini $x dir)
    user=$(get_ini $x user)
    pass=$(get_ini $x pass)
    dop=$(get_ini $x dop)
    attempts=5     
    sleeptime=3     
    counter=0      
    if [ -n $server ] && [ -n $x ]; then                 
    while [ $counter -lt $attempts ] ; do
     ping -c 1 -W 1 $server

     if [ $? -eq 0 ]; then           
        echo Music server reached
#        sudo umount /mnt/$x
        rm /home/tc/music/$x
        
        mkdir /mnt/$x
        if [ "$fs" == "cifs" ]; then
    	    sudo mount -t cifs //$server/$share /mnt/$x -o noperm,user=$user,pass=$pass,iocharset=utf8,rsize=32768,wsize=32768$dop
    	else
    	    sudo /sbin/mount.nfs $server:/$share /mnt/$x -o nolock
    	fi

	if [ -n "$dir1" ]; then
	    ln -s /mnt/$x/$dir1 /home/tc/music/$x
	else
	    ln -s /mnt/$x /home/tc/music/$x
	fi
        break                        
     fi                              
     counter=$(( $counter + 1 ))     
     sleep $sleeptime                
    done
    fi
done