#!/bin/sh

tce=$(cat /etc/sysconfig/backup_device)
lang=$(cat /mnt/$tce/language/default)

[ "$lang" == "" ] && lang=ru

source /opt/var.sh
source /mnt/$tce/language/lang_$lang

ncpu=$(cat /tmp/numcpu)

v_bin() {
    decnum=$(printf "%d" $1)
    binary=
    number=$decnum
            
    while [ $decnum -ne 0 ]
    do
    	bit=$(expr $decnum % 2)
        binary=$bit$binary
    	decnum=$(expr $decnum / 2)
    done
    len=${#binary}
    while [ $len -ne 9 ]
    do
    	binary="0$binary"
	len=${#binary}
    done
    echo $binary
}

cat <<EOF
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">

<head>
<meta content="yes" name="apple-mobile-web-app-capable" />
<meta content="text/html; charset=utf-8" http-equiv="Content-Type" />
<meta content="minimum-scale=1.0, width=device-width, maximum-scale=0.6667, user-scalable=no" name="viewport" />
<link href="css/style.css" rel="stylesheet" media="screen" type="text/css" />
<script src="js/functions.js" type="text/javascript"></script>
<title>TinySqueeze - $mnu2_desc</title>
</head>
<body>
<style>
#wrapp {
    top: 0;
    left: 0;
    position:fixed;
    background-color:rgba(0,0,0,0.5);
    width: 100%;
    height: 100%;
    z-index: 10000;
}
.tt {
    position: relative;
    background-color:none;
    width: 400px;
    height: 200px;
    margin: 20% auto auto auto;
    overflow: hidden;
}
</style>
<script>
    var loadtop='$cfg_loadtop';
    var savetop='$cfg_savetop';
    var loadbtn='$cfg_load';
    var savebtn='$cfg_save';

    function reload_page(a){
	setInterval('location.reload()',a);
    }

    function openbox(ff) {
	if (ff != 'none') {
	    div = document.getElementById("wrapp");
	    topp = document.getElementById("topper");
	    if (div.style.display == 'block') {
		div.style.display = 'none';
	    }
	    else {
		but1 = document.getElementById("but1");
		tw = document.getElementById("typew");
		tw.value=ff;
		if (ff == 'load')
	    	    but1.value = loadbtn;
	    	else
	    	    but1.value = savebtn;
	    	    
		div.style.display = 'block';
		if (ff == 'load')
		    topp.innerHTML = loadtop;
		else
		    topp.innerHTML = savetop;
	    }
	    cfg = document.getElementById("CFG");
	    cfg.value='none';
	}
    }
</script>
<div id="wrapp" style="display:none">
<div class="tt">
<ul class="pageitem" style="background-color:white;">
<li id="topper" class="textbox">
</li>
<li class="textbox">
<form action="http://${HTTP_HOST}/cgi-bin/submit_cfg.yy" target="myIFR" method="GET">
<div style="width:100%;margin-bottom:8px;"><label>$cfg_name: </label>
<datalist id="cars"></datalist><input name="cfg" list="cars" id="cars-input" />
<input name="remove" type="submit" value="X"  onclick="reload_page(500);" />
<div style="display:none;"><input name="typew" id="typew" type="text" value=""  /></div>
<script>
EOF
ai=0
echo "var listfiles = new Array();"
echo "var desc = new Array();"
find /mnt/$tce/ondemand/*.cfg | while read line
do
    aad=$(cat $line)
    aad=${aad%%;*}
    aad=${aad#*description=}
    line=${line%.*}
    line=${line##*\/}
    echo "listfiles[$ai]='$line';"
    echo "desc[$ai]='$aad';"
    ai=$(( $ai + 1))
done

a=$(cat /home/tc/lastcfg)
[ -n "$a" ] && cfg_button=$a

cat <<EOF
    var options = '';
    for(var i = 0; i < listfiles.length; i++) {
	options += '<option value="'+listfiles[i]+'" />';
	}
    document.getElementById("cars").innerHTML = options;
    document.getElementById("cars-input").addEventListener('input',
    function () {
	var input0 = document.getElementById("cars-input");
	var datalist0 = document.getElementById("cars");
	for(var j = 0; j < datalist0.options.length; j++) {
	    if (datalist0.options[j].value == input0.value)
	      {break;}
	    }
	var d0 = document.getElementById("mydesc");
	if (typeof desc[j] == "undefined") 
	    d0.value = '';
	else
	    d0.value = desc[j];
	    
    });
    
</script>

</div>
<table width="100%">
<tr><td style="width:20%;border-top: none !important;vertical-align:top;">$cfg_desc:</td>
<td style="border-top: none !important;">
<textarea name="mydesc" rows="4" cols="1" id="mydesc" style="width:100%;resize:none;">
</textarea></td>
</tr>
</table>

<div style="margin:8px 0 8px 20px;float:left;">
    <input name="typ" type="submit" value="Save" id="but1" onclick="reload_page(1000);"  />
</div>
<div style="margin:8px 6px 8px 0;float:right;">
    <input type="button" value="$cfg_cancel" onclick="openbox();" />
</div>
</form>
</li>
</ul>

</div>
</div>

<div id="topbar">
	<div id=rightnav>
	<select id="CFG" onchange="openbox(this.value);" style="background:#dddee0;border:1px solid black;">
	    <option value="none">$cfg_button</option>
	    <option value="load">$cfg_load...</option>
	    <option value="save">$cfg_save...</option>
	</select>
	</div>
	<div id="leftnav">
		<a href="index.yy"><img src="images/home.png" /></a></div>
	<div id="title">$mnu2_desc</div>
</div>
EOF

if [ $audiodev == usb ]; then\
    a1=selected
    a2=""
    a3=""
else
    if [ $audiodev == pci ]; then\
	a1=""
	a2=selected
	a3=""
    else
	a1=""
	a2=""
	a3=selected
    fi
fi

cat <<EOF
<style>
.bbox {
    float:left;
    width:230px;
}
.bbox1 {
    float:left;
    width:530px;
}
.bbox2 {
    float:left;
    width:350px;
}

</style>
<div id="content" style="max-width:800px;margin:auto;">
<div class="bbox">
<span class="graytitle">$mnu2_sect1</span>
EOF

if [ 1 -eq 0 ]; then
cat <<EOF
	<ul class="pageitem">
		<form action="http://${HTTP_HOST}/cgi-bin/submit_audio.yy" target="myIFR" method="GET">
		<li class="select"><select name="audiodev">
			<option $a1 value="usb">USB Audio</option>
			<option $a2 value="pci">PCI Card ESI Juli@/Asus</option>
			<option $a3 value="pcia">PCI Card Analog Output</option>
		</select><span class="arrow"></span> </li>
	
		<li class="button">
		<input name="player_save" type="submit" value="$mnu_apply" /></li>
		</form>
	</ul>
EOF
fi

nrlist="1 2 5 6 8 10 16 20"

alsalist="auto 4 8 16 32 64 128 256 512 1024 2048 4096 8192 16384"
alsaprio="standart high highest extreme"

alsabuf=$(cat /home/tc/.asoundrc | grep buffer_size)
m2=$(echo $alsabuf| cut -c 1)
if [ "$m2" == "#" ]; then
    alsabuffer=auto
else
    alsabuf=${alsabuf%\"*}
    alsabuffer=${alsabuf#*\"}
    
fi
boot=$(cat /etc/sysconfig/backup_device)
fname=/mnt/$boot/onboot.lst
fl=$(cat $fname | grep "Linux-PAM")
if [ -n "$fl" ]; then
    alsart=$(cat /etc/security/limits.conf|grep rtprio|cut -d " " -f 4)
    if [ $alsart -eq 99 ]; then
	alsart=extreme
    else
	if [ $alsapr -eq 95 ]; then
	    alsart=highest
	else
	    alsart=high
	fi
    fi
else
    alsart=standart
fi

cat <<EOF
	<span class="graytitle">$mnu2_sect2</span>
	<ul class="pageitem">
		<form action="http://${HTTP_HOST}/cgi-bin/submit_audio.yy" target="myIFR" method="GET">
		<li class="select"><select name="alsaprio">
EOF
for x in $alsaprio
do
    tsel=""
    [ $x == $alsart ] && tsel=selected
    if [ $x == high ]; then
	x2="$x (default)"
    else
	x2=$x
    fi
    echo "<option $tsel value=$x>Alsa priority: $x2</option>"
done
echo "</select><span class='arrow'></span> </li>"
echo "<li class='select'><select name='nrpacks'>"

for x in $nrlist
do
    tsel=""
    [ $x == $nrpacks ] && tsel=selected
    if [ $x == 8 ]; then
	x2="$x (default)"
    else
	x2=$x
    fi
    echo "<option $tsel value=$x>NRPACKS: $x2</option>"
done

cat <<EOF
		</select><span class="arrow"></span> </li>
		<li class="button">
		<input name="atweak_save" type="submit" value="$mnu_apply" /></li>
		</form>
	</ul>
</div>
EOF

if [ "$sqlog" == "yes" ]; then
    logcheck=checked
else
    logcheck=""
fi

cat <<EOF
<div class="bbox1" id="sqlitebox">
<span class="graytitle">$mnu2_sect4</span>
	<form action="http://${HTTP_HOST}/cgi-bin/submit_audio.yy" target="myIFR" method="GET">
	<ul class="pageitem" style="margin-bottom:3px;">
		<li class='smallfield'><span class='name'>$mnu2_s45:</span><input name="squeezename" type="text" placeholder="$mnu2_s45e" value="$squeezeplayername" /></li>
		<li class='smallfield'><span class='name'>$mnu2_s46:</span><input name="sqmacaddr" type="text"  placeholder="$mnu2_s46e" value="$sqmacaddr" /></li>
		
EOF
if [ $ncpu -gt 1 ]; then
    echo "<li class=\"select\"><select name=\"audiocpu\">"
    tsel=
    [ $audiocpu = disabled ] && tsel=selected
    echo "<option $tsel value=disabled>USB audio IRQ bind CPU: disable</option>"
    x=0
    while [ $ncpu -gt $x ]; do
    	let "x=x+1"
        tsel=
        [ $x == $audiocpu ] && tsel=selected
    	echo "<option $tsel value=$x>USB audio IRQ bind CPU: $x</option>"
    done
    cat <<EOF
    </select><span class='arrow'></span></li>
    <li class='textbox'><b>Bind to CPU:</b>
    <div style='float:right;'>
EOF
    bcpu=$(v_bin $sqcpu)
    i=$((${#bcpu} - 1))
    x=0
    while [ $ncpu -gt $x ]
    do
	let "x=x+1"
	ck=
	a=${bcpu:$i:1}
	[ $a = 1 ] && ck=checked
	echo "<div style='float:left'><span style='margin-left:5px;'>$x</span><br>
	<input type='checkbox' name='sqcpu$x' id='sqcpu$x' style='-webkit-appearance:checkbox; width:27px;float:left;'  $ck>
        </div>"
        let "i=i-1"
    done

    cat <<EOF
    </div></li>
    <li class='textbox'><b>Output thread to CPU:</b>
    <div style='float:right;'>
EOF
    bcpu=$(v_bin $sqoutcpu)
    i=$((${#bcpu} - 1))
    x=0
    while [ $ncpu -gt $x ]
    do
	let "x=x+1"
	ck=
	a=${bcpu:$i:1}
	[ $a = 1 ] && ck=checked
	echo "<div style='float:left'><span style='margin-left:5px;'>$x</span><br>
	<input type='checkbox' name='sqoutcpu$x' id='sqoutcpu$x' style='-webkit-appearance:checkbox; width:27px;float:left;'  $ck>
	</div>"
	let "i=i-1"
    done
    echo "</div></li>"
fi

cat <<EOF
		<li class="checkbox"><span class="name">Enable log</span>
		<input name="sqlog" type="checkbox" $logcheck /> </li>
		<li class="select"><select name="sqprio">
EOF
for x in $(seq 20 5 95)
do
    tsel=""
    [ $x == $sqprio ] && tsel=selected
    echo "<option $tsel value=$x>prio: $x</option>"
done
echo "</select><span class='arrow'></span></li>"


sq_alsabuf=${sqalsa%%:*}
sq_alsap=${sqalsa#*:}
sq_alsap=${sq_alsap%%:*}
sq_mmap=${sqalsa##*:}
sq_alsalist="20 40 50 60 80 100 120 150 200 250 300 350 500"
sq_periodlist="2 3 4 8 16 64 128"

cat <<EOF
	</ul>
	<script>
	function onchangeA() {
	  if (document.getElementById('sq_alsabuf').value > 500) 
		document.getElementById('sq_alsabuf').value = 500;
	  document.getElementById('arange').value = document.getElementById('sq_alsabuf').value;
	}
	
	function onchangeW() {
	  document.getElementById('sq_alsabuf').value = document.getElementById('arange').value;
	}
	</script>
	<ul class="pageitem" style="float:left;width:240px;">
	    <li class="smallfield"><span class="name" style="width:70%">ALSA Buffer (ms): </span>
	    <input type="text" name="sq_alsabuf" id="sq_alsabuf" onkeypress="return event.charCode >= 48 && event.charCode <= 57" oninput="onchangeA()" value="$sq_alsabuf" style="width:50px;" /></li>
	    <input type="range" oninput="onchangeW()" id="arange" min=20 max=500 value="$sq_alsabuf" style="width:100%" />
EOF
echo "<li class='select'><select name='sq_period'>"
for x in $sq_periodlist
do
    tsel=""
    if [ $x = 4 ]; then
	x2="$x (default)"
    else
	x2=$x
    fi
    [ $x = $sq_alsap ] || [ -z "$sq_alsap" ] && tsel=selected
    echo "<option $tsel value=$x>ALSA periods: $x2</option>"    
done
tmap1=""
tmap2=""
if [ "$sq_mmap" == "1" ]; then
    tmap2=selected
else
    tmap1=selected
fi

cat <<EOF
		</select><span class="arrow"></span></li>
		<li class="select"><select name="sq_mmap">
		    <option $tmap1 value="0">MMAP: 0</option>
		    <option $tmap2 value="1">MMAP: 1</option>
		</select><span class="arrow"></span></li>
		<li class="select"><select name="sqbuffer">
EOF
sq_streambuflist="260 300 400 1024 2048 4096 8192 16384 32768 50000 100000"
for x in $sq_streambuflist
do
    tsel=""
    [ $x == $sqbuffer ] && tsel=selected
    if [ $x == 4096 ]; then
	x2="$x (default)"
	[ -z "$sqbuffer" ] && tsel=selected
    else
	x2="$x KB"
    fi
    echo "<option $tsel value=$x>Stream buf: $x2</option>"
done
echo "</select><span class='arrow'></span> </li>"
echo "<li class='select'><select name='sqoutbuffer'>"

sq_outbuflist="4096 8192 16384 20480 32768 50000 100000"
for x in $sq_outbuflist
do
    tsel=""
    [ $x == $sqoutbuffer ] && tsel=selected

    if [ $x == 8192 ]; then
	x2="$x (default)"
	[ -z "$sqoutbuffer" ] && tsel=selected
    else
	x2="$x KB"
    fi
    echo "<option $tsel value=$x>Output buf: $x2</option>"
done
echo "</select><span class='arrow'></span> </li>"
echo "<li class='select'><select name='sqpipe'>"

[ $sqpipe = standart ] && tsel=selected
echo "<option $tsel value=standart>Output: standart</option>"

for file in /home/tc/sq/pipe_*;do
    file=${file#*_}
    tsel=""
    [ $file == $sqpipe ] && tsel=selected

    echo "<option $tsel value=$file>Output: $file</option>"
done

limcheck=
[ "$limitrate" == "yes" ] && limcheck=checked

upscheck=
[ "$upsample" == "yes" ] && upscheck=checked

fixrcheck=
[ "$fixrate" == "yes" ] && fixrcheck=checked

cat <<EOF
		</select><span class="arrow"></span> </li>
	</ul>
	<ul class="pageitem" style="float:left;width:250px;">
		<li class="checkbox"><span class="name">Limit Samplerate</span>
		<input name="limitrate" type="checkbox" $limcheck /> </li>
		<li class="select"><select name="maxrate">
EOF

rates=$(cat /tmp/formats | grep rate |head -1)
if [ -z "$rates" ]; then
    sudo /bin/rm -f /tmp/formats
    sudo /home/tc/sq/hw_params | grep "Formats:\|rates:" > /tmp/formats
    rates=$(cat /tmp/formats | grep rate |head -1)
fi
rates=${rates#*:}
[ -z "$maxrate" ] && maxrate=${rates##* }

for i in $rates
do
    tsel=""
    [ "$maxrate" == "$i" ] && tsel=selected
    echo "<option $tsel value='$i'>MAX Samplerate: $i Hz</value>"
done
cat <<EOF
		</select><span class="arrow"></span></li>
		<li class="checkbox"><span class="name">Fix samplerate</span>
		<input name="fixrate" type="checkbox" $fixrcheck /> </li>
		<span class="arrow"></span> </li>
		<li class="checkbox" style="display:none;"><span class="name">Resample</span>
		<input name="upsample" type="checkbox" $upscheck /> </li>

		<li class="select"><select name="format">
EOF

formats=$(cat /tmp/formats | grep "Format" | head -1)
formats=${formats#*:}
[ -z "$format" ] && format=${formats##* }

for i in $formats
do
    tsel=""
    [ "$format" == "$i" ] && tsel=selected
    echo "<option $tsel value='$i'>Format: $i</value>"
done

if [ "$brutefir" == "yes" ]; then
    brutecheck=checked
    bvis=block
else
    brutecheck=""
    bvis=none
fi
cat <<EOF
		</select><span class="arrow"></span> </li>

		<li class="button">
		<input name="sqlite_save" type="submit" value="$mnu_apply" /></li>
	
	</ul>
	</form>
</div>
<script>
function brutevis(a){
    div = document.getElementById("brute");
    if (a) {
	div.style.display='block';
    }
    else {
	div.style.display='none';
    }
}
</script>
EOF
brconfig=/home/tc/.brutefir_config
intf=$(cat $brconfig | grep float_bits)
intf=${intf#*: }
intf=${intf%%;*} #comment remove
if [ $intf -eq 32 ]; then
    intf1=selected
    intf2=""
else
    intf2=selected
    intf1=""
fi

bruterate=$(cat $brconfig | grep sampling_rate)
bruterate=${bruterate#*: }
bruterate=${bruterate%%;*} #comment remove

psave=$(cat $brconfig | grep powersave)
psave=${psave#*: }
psave=${psave%%;*} #comment remove
if [ "$psave" == "false" ]; then
    pschech=""
else
    pscheck=checked
fi

flen=$(cat $brconfig | grep filter_length)
flen=${flen#*: }
flen=${flen%%;*} #comment remove

atten=$(cat $brconfig | grep attenuation)
atten=${atten#*: }
atten=${atten%%;*} #comment remove

cat <<EOF
<div class="bbox2">
    <span class="graytitle">BruteFIR</span>
    <form action="http://${HTTP_HOST}/cgi-bin/submit_audio.yy" target="myIFR" method="GET">
    <ul class="pageitem">
	<li class="checkbox"><span class="name">Enable</span>
	<input name="brutefir" type="checkbox" $brutecheck onchange="brutevis(this.checked);" /> </li>
	<div id="brute" style="display:$bvis"><hr>
EOF

if [ $ncpu -gt 1 ]; then
    cat <<EOF
    <li class="textbox"><b>BruteFIR CPU:</b>
    <div style="float:right;">
EOF
    bcpu=$(v_bin $brutecpu)
    i=$((${#bcpu} - 1))
    x=0
    while [ $ncpu -gt $x ]
    do
	let "x=x+1"
	ck=
	a=${bcpu:$i:1}
	[ $a = 1 ] && ck=checked
	echo "<div style='float:left'><span style='margin-left:5px;'>$x</span><br>
	<input type='checkbox' name='brutecpu$x' id='brutecpu$x' style='-webkit-appearance:checkbox; width:27px;float:left;'  $ck>
        </div>"
        let "i=i-1"
    done

echo "</div></li>"
fi

cat <<EOF
	<li class="select"><select name="bruteformat">
	    <option value="32" $intf1>Internal format: 32 bit</option>
	    <option value="64" $intf2>Internal format: 64 bit</option>
	</select><span class="arrow"></span></li>
	<li class="select"><select name="samplerate">
EOF
[ -z "$rates" ] && echo "<option $tsel value=none>Samplerate: none</value>"
for i in $rates
do
    tsel=""
    [ "$bruterate" == "$i" ] && tsel=selected
    echo "<option $tsel value=$i>Samplerate: $i Hz</value>"
done

cat <<EOF
	</select><span class="arrow"></span></li>
	<li class="checkbox"><span class="name">Powersave</span>
	<input name="powersave" type="checkbox" $pscheck /> </li>
	<li class="textbox"><b>Filter length:</b>
	<input name="filterlen" type="text" value="$flen" placeholder="Ex:,16384" />
	</li>
	<li class="select"><select name="attenuation">
EOF
attlist="0.0 5.0"
for i in $attlist
do
    tsel=""
    [ "$atten" == "$i" ] && tsel=selected

    echo "<option $tsel value='$i'>Attenuation: $i (db)</value>"
done

fleft=$(cat $brconfig | sed -n '/coeff "drc_l"/,//p'| grep filename)
fleft=${fleft##*/}
fleft=${fleft%\"*} #comment remove

fright=$(cat $brconfig | sed -n '/coeff "drc_r"/,//p'| grep filename)
fright=${fright##*/}
fright=${fright%\"*} #comment remove

cat <<EOF
	    </select><span class="arrow"></span></li>
	<li class="select"><select name="filterleft">
EOF
    drcpath=/home/tc/music/drc
    ls $drcpath/*.bin | while read line
    do
	line=${line##*/}
	tsel=""
	[ $line == $fleft ] && tsel=selected
	echo "<option value=\"$line\" $tsel>Left channel filter: $line</option>"
    done
cat <<EOF
	</select><span class="arrow"></span></li>
	<li class="select"><select name="filterright">
EOF
    ls $drcpath/*.bin | while read line
    do
	line=${line##*/}
	tsel=""
	[ $line == $fright ] && tsel=selected
	echo "<option value=\"$line\" $tsel>Right channel filter: $line</option>"
    done
cat <<EOF
	    </select><span class="arrow"></span></li>
	</div>
	<li class="button">
	<input name="brute_save" type="submit" value="$mnu_apply" /></li>
    </ul>
</div>
</div>

<iframe name="myIFR" style="display: none"></iframe>
<iframe name="myIFR2" style="display: none">
</iframe>
EOF
echo "</body>"
echo "</html>"
