#!/bin/sh
cgi_getvars()
{
    [ $# -lt 2 ] && return
    local q p k v s
# get query
    case $1 in
    	GET)
	        [ ! -z "${QUERY_STRING}" ] && q="${QUERY_STRING}&"
	        echo "${QUERY_STRING}" 
    	    ;;
    esac
    shift
    s=" $* "
    # parse the query data
    while [ ! -z "$q" ]; do
    	p="${q%%&*}"  # get first part of query string
        k="${p%%=*}"  # get the key (variable name) from it
    	v="${p#*=}"   # get the value from it
        q="${q#$p&*}" # strip first part from query string
    	
        [ "$1" = "ALL" -o "${s/ $k /}" != "$s" ] && \
	    eval "$k=$v"
    done
    return
}

varfile=/opt/var.sh

v_hex() {
    binary=$1
    
    bnumber=$binary
    power=1
    while [ $binary -ne 0 ]
    do
	rem=$(expr $binary % 10)
	decimal=$((decimal+(rem*power)))
        power=$((power*2))
        binary=$(expr $binary / 10)
    done

    printf '0x%x' "$decimal"
}

v_read(){
    echo $(grep "^$1=" $varfile | sed -e "s|^$1=||")
}
v_write(){
    sed -e "s/^$1=.*/$1=$2/" $varfile > /tmp/temp.$$
    sudo /bin/mv -f /tmp/temp.$$ $varfile
}

v_write2(){
    str="cat $varfile"
    for x in $1
    do
    	pre1=$(echo $x | cut -f 1 -d ':')
        pre2=$(echo $x | cut -f 2 -d ':')
        echo $pre1 $pre2
        str=$(echo "$str | sed -e 's|^$pre1=.*|$pre1=$pre2|'")
    done
    str=$(echo $str " > /tmp/temp.$$ && sudo /bin/mv -f /tmp/temp.$$ $varfile")
    eval $str
}

#echo "${QUERY_STRING}">123.txt
# register all GET variables
cgi_getvars GET ALL

#-------- 2 Audio
boot=$(cat /etc/sysconfig/backup_device)
fname="/mnt/$boot/onboot.lst"
ncpu=$(cat /tmp/numcpu)

sqzlite=$(v_read sqzlite)

#player_save
if [ -n "$player_save" ]; then
    $(v_write audiodev $audiodev)
    num2=0
    if [ $audiodev == usb ]; then
#	spk=front
	#delete pci-utils
	if [ -n $(cat $fname | grep "pci-utils") ]; then
	    cat $fname | sed /pci-utils/d >/tmp/temp.$$$
	    sudo /bin/mv -f /tmp/temp.$$$ $fname
	fi
    else
#	spk=iec958
	[ $audiodev == pci ] && num2=1
	#include pci-utils
	if [ -z $(cat $fname | grep "pci-utils") ]; then
	    cat $fname| sed "9ipci-utils.tcz" >/tmp/temp.$$$
	    sudo /bin/mv -f /tmp/temp.$$$ $fname
	fi
    fi #audiodev
    
    sqcpu=$(v_read sqcpu)
    sqoutcpu=$(v_read sqoutcpu)
    
    cat /proc/asound/cards |grep "]:"| while read line; do
    fl=$(echo $line | grep "ICE1724\|"AV200"")
    if [ -z "$fl" -a $audiodev == usb ] || [ -n "$fl" -a $audiodev == pci ] ; then
        number=${line:0:1}
        sdev=${line#*]: }
    
	echo "$number,$num2" >/opt/alsa/devnum
	echo $sdev >/opt/alsa/devname

        break
    fi
    done

    sudo /usr/bin/pkill squeezelite
    sudo /usr/bin/pkill writeloop
    sudo /usr/bin/pkill catloop
    sudo /usr/bin/pkill playhrt
    sudo /usr/bin/pkill aplay

    sleep 1.5

    sqname=$(v_read squeezeplayername)
    sqmacaddr=$(v_read sqmacaddr)
    dev=$(v_read audiodev)
    alsabuf=$(v_read sqalsa)
    sqbuffer=$(v_read sqbuffer)
    sqoutbuffer=$(v_read sqoutbuffer)
    sqprio=$(v_read sqprio)
    sqpipe=$(v_read sqpipe)
    format=$(v_read format)
    limitrate=$(v_read limitrate)    
    maxrate=$(v_read maxrate)

    if [ -z "$maxrate" ]; then
	rates=$(cat /tmp/formats | grep rate | head -1)
	rates=${rates#*:}
	maxrate=${rates##* }
	$(v_write maxrate $maxrate)
    fi

    srate=""
    [ "$limitrate" == "yes" ] && srate="-r $maxrate"

    cpu2=""
    [ -n "$sqcpu" ] && [ "$sqcpu" != "0x0" ] && cpu2="/usr/bin/taskset $sqcpu"
    if [ $sqpipe == standart ]; then
        [ $audiodev == usb ] && spk=front || spk=iec958
	
	sudo $cpu2 $sqzlite -o $spk -n $squeezeplayername -a $sqalsa -b $sqbuffer:$sqoutbuffer $srate -p $sqprio -z >/dev/null
#	sudo /usr/bin/chrt -f 60 $cpu2 $sqzlite -o $spk -n $squeezeplayername -a $sqalsa -b $sqbuffer:$sqoutbuffer $srate -p $sqprio -z >/dev/null
	sleep 1.5
	a=$(/usr/bin/ps2 -C squeezelite -L | tail -2 | head -1 | awk '{print $2}')
	if [ -n "$a" ]; then
	    sudo /usr/bin/renice -10 $a
	    sudo /usr/bin/taskset -p $sqoutcpu $a
	fi
    else
	if [ -z "$format" ]; then
	    formats=$(cat /tmp/formats | grep Format | head -1)
	    formats=${formats#*:}
	    format=${formats##* }
	    $(v_write format $format)
	fi

	formatbit=32
	[ $format == S24_3LE ] && formatbit=24
	[ $format == S16_LE ] && formatbit=16

	cat /home/tc/sq/pipe_$sqpipe | sed "s/\#device/$num1/;s/\#format/$format/" >/tmp/temp.1
	sudo /bin/mv -f /tmp/temp.1 /home/tc/sq/pipe3

	if [ -n "$sqmacaddr" ]; then
	    sudo /usr/bin/chrt -f 60 $cpu2 $sqzlite -o - -n $squeezeplayername -m $sqmacaddr -a $formatbit -b $sqbuffer:$sqoutbuffer $srate -j /home/tc/sq/pipe3 -z
	else
	    sudo /usr/bin/chrt -f 60 $cpu2 $sqzlite -o - -n $squeezeplayername -a $formatbit -b $sqbuffer:$sqoutbuffer $srate -j /home/tc/sq/pipe3 -z
	fi
	sleep 1.5
	a=$(pidof $sqzlite)
#	if [ -n "$pa" ]; then
#	    sudo /usr/bin/renice -10 $pa
#	    sudo /usr/bin/chrt -p -f 95 $pa
#	fi

	pa=$(pidof aplay)
	ph=$(pidof playhrt)
	if [ -n "$pa" ]; then
	    sudo /usr/bin/renice -10 $pa
	    sudo /usr/bin/chrt -p -f 95 $pa
	fi
	if [ -n "$ph" ]; then
	    sudo /usr/bin/renice -10 $ph
	    sudo /usr/bin/chrt -p -f 95 $ph
	fi
#    a=$(/usr/bin/ps2 -C squeezelite -L | tail -2 | head -1 | awk '{print $2}')
#    if [ -n "$a" ]; then

    fi
    
fi #player_save

#atweak_save - Audio tweak save
if [ -n "$atweak_save" ]; then
    if [ -n "$alsaprio" ]; then
	if [ $alsaprio == standart ] && [ -n $(cat $fname | grep "Linux-PAM") ]; then
	    cat $fname | sed /PAM/d >/tmp/temp.$$$
	    sudo /bin/mv -f /tmp/temp.$$$ $fname
	else
	    if [ -z $(cat $fname | grep "Linux-PAM") ]; then
		cat $fname| sed "7iLinux-PAM.tcz" >/tmp/temp.$$$
		sudo /bin/mv -f /tmp/temp.$$$ $fname
	    fi
	    
	    if [ $alsaprio == high ]; then
		aprio=90
		anice=-10
	    else
		if [ $alsaprio == extreme ]; then
		    aprio=99
		    anice=-19
		else # highest
		    aprio=95
		    anice=-15
		fi
	    fi
	    ff1=/etc/security/limits.conf

	    cat $ff1 | sed "s|^.*rtprio.*|@audio - rtprio $aprio|;s|^.*nice.*|@audio - nice $anice|" >/tmp/temp.$$$
	    sudo /bin/mv -f /tmp/temp.$$$ $ff1
	fi
    fi #alsaprio
    
#    $(v_write2 "alsaperiods:$alsaperiods nrpacks:$nrpacks")
    $(v_write nrpacks $nrpacks)

    audiodev=$(v_read audiodev)
    
    if [ $audiodev == usb ]; then
	$(sudo /sbin/modprobe -r snd-usb-audio)
	$(sudo /sbin/modprobe snd-usb-audio nrpacks=$nrpacks)
    fi
fi #atweak_save

if [ -n "$sqlite_save" ]; then
#    case $format in
#	"S32_LE") ff=32
#	;;
#	"S16_LE") ff=16
#	;;
#	"S24_LE") ff=24
#	;;
#	"S24_3LE") ff=24_3
#	;;
#    esac
#    sqalsa=$sq_alsabuf:$sq_period:$ff:$sq_mmap
    sqalsa=$sq_alsabuf:$sq_period::$sq_mmap

    bcpu=
    for i in $(seq 1 16)
    do
	var=sqcpu$i
	eval a=\$$var
	[ $a == on ] && bcpu="1$bcpu" || bcpu="0$bcpu"
    done
    mcpu=$(v_hex $bcpu)

    bcpu=
    for i in $(seq 1 16)
    do
	var=sqoutcpu$i
	eval a=\$$var
	[ $a == on ] && bcpu="1$bcpu" || bcpu="0$bcpu"
    done
    ocpu=$(v_hex $bcpu)
    
    [ -n "$sqlog" ] && slog=yes || slog=no

    fixr=no
    if [ -n "$limitrate" ]; then
	srate="-r $maxrate"
	if [ -n "$fixrate" ]; then
	    fixr=yes
	    srate="$srate-$maxrate"
	fi
	limrate=yes
    else
	srate=""
	limrate=no
    fi

    if [ -n "$upsample" ]; then
	usample=yes
	supsample="-u vLs:18:3"
    else
	usample=no
	supsample=""
    fi

    [ -n "$fixrate" ] && fixr=yes || fixr=no

    [ -z "$squeezename" ] && squeezename="TinySqueeze";
    sqmacaddr=${sqmacaddr//%3A/:}

    [ "$sqpipe" != "standart" ] && $(v_write brutefir no)

    $(v_write2 "audiocpu:$audiocpu sqcpu:$mcpu sqoutcpu:$ocpu sqpipe:$sqpipe limitrate:$limrate maxrate:$maxrate fixrate:$fixr upsample:$usample sqlog:$slog format:$format squeezeplayername:$squeezename sqmacaddr:$sqmacaddr sqbind:$bind sqbuffer:$sqbuffer sqoutbuffer:$sqoutbuffer")

    $(v_write sqalsa $sqalsa)
    [ -n "$sqprio" ] && $(v_write sqprio $sqprio)

    num1=$(cat /opt/alsa/devnum)

    brutefir=$(v_read brutefir)
    sudo /usr/bin/pkill brutefir.real

    sudo /usr/bin/pkill squeezelite
    sudo /usr/bin/pkill writeloop
    sudo /usr/bin/pkill catloop
    sudo /usr/bin/pkill playhrt
    sudo /usr/bin/pkill aplay
    sleep 2.0
    cpu2=""
    [ -n "$sqcpu" ] && [ "$sqcpu" != "0x0" ] && cpu2="/usr/bin/taskset $sqcpu"

    if [ $sqpipe == standart ]; then
	audiodev=$(v_read audiodev)
        [ $audiodev == usb ] && spk=front || spk=iec958

	sudo $cpu2 $sqzlite -o $spk -n $squeezename -a $sqalsa -b $sqbuffer:$sqoutbuffer $srate $supsample -p $sqprio -z >/dev/null
	sleep 1.5
	a=$(/usr/bin/ps2 -C squeezelite -L | tail -2 | head -1 | awk '{print $2}')
	if [ -n "$a" ]; then
	    sudo /usr/bin/renice -10 $a
	    sudo /usr/bin/taskset -p $sqoutcpu $a
	fi
	
	if [ "$brutefir" == "yes" ]; then
	    brconfig=/home/tc/.brutefir_config
	    cat $brconfig | sed "/sampling_rate/s| .*#| $maxrate; #|1"|\
	    sed "/sample:/s| .*;| \"$format\";|g"  > /tmp/temp.1
	    sudo /bin/mv -f /tmp/temp.1 $brconfig

	    brutecpu=$(v_read brutecpu)
	    cpu2=
	    [ -n "$brutecpu" ] && [ "$brutecpu" != "0x0" ] && cpu2="/usr/bin/taskset $brutecpu"
	    $cpu2 $brutecpu /usr/lib/brutefir/brutefir.real -nodefault /home/tc/.brutefir_config -daemon
	fi
    else
	if [ -z "$format" ]; then
	    formats=$(cat /tmp/formats | grep Format | head -1)
	    formats=${formats#*:}
	    format=${formats##* }
	    $(v_write format $format)
	fi

	formatbit=32
	[ $format == S24_3LE ] && formatbit=24
	[ $format == S16_LE ] && formatbit=16

	cat /home/tc/sq/pipe_$sqpipe | sed "s/\#device/$num1/;s/\#format/$format/" >/tmp/temp.1
	sudo /bin/mv -f /tmp/temp.1 /home/tc/sq/pipe3
    
	if [ -n "$sqmacaddr" ]; then
	    sudo /usr/bin/chrt -f 60 $cpu2 $sqzlite -o - -n $squeezename -m $sqmacaddr -a $formatbit -b $sqbuffer:$sqoutbuffer $srate $supsample -j /home/tc/sq/pipe3 -z
	else
	    sudo /usr/bin/chrt -f 60 $cpu2 $sqzlite -o - -n $squeezename -a $formatbit -b $sqbuffer:$sqoutbuffer $srate $supsample -j /home/tc/sq/pipe3 -z
	fi
	sleep 1.5
	pa=$(pidof aplay)
	ph=$(pidof playhrt)
	if [ -n "$pa" ]; then
	    sudo /usr/bin/renice -10 $pa
	    sudo /usr/bin/chrt -p -f 95 $pa
	fi
	if [ -n "$ph" ]; then
	    sudo /usr/bin/renice -10 $ph
	    sudo /usr/bin/chrt -p -f 95 $ph
	fi

    fi

	
fi #sqlite_save

if [ -n "$brute_save" ]; then
    if [ -n "$brutefir" ]; then
	brutefir=yes

	[ -n "$powersave" ] && psave=true || psave=false
	format=$(v_read format)

	drcpath=/home/tc/music/drc/
	brconfig=/home/tc/.brutefir_config
	filterlen=${filterlen/%2C/,}
	cat $brconfig | sed "/float_bits/s| .*#| $bruteformat; #|1" |\
	   sed "/sampling_rate/s| .*#| $samplerate; #|1" |\
	   sed "/filter_length/s| .*#| $filterlen; #|1" |\
	   sed "/powersave/s| .*#| $psave; #|1" |\
	   sed "/attenuation/s| .*#| $attenuation; #|g" |\
	   sed "/sample:/s| .*;| \"$format\";|g" |\
	   sed "/left_in\"\//s| .*;| \"left_in\"\/$attenuation;|1" |\
	   sed "/right_in\"\//s| .*;| \"right_in\"\/$attenuation;|1"|\
	   sed "/drc_l/,/}/s|filename.*;|filename: \"$drcpath$filterleft\";|1"|\
	   sed "/drc_r/,/}/s|filename.*;|filename: \"$drcpath$filterright\";|1" >/tmp/temp.1
	sudo /bin/mv -f /tmp/temp.1 $brconfig

	cpu=
	for i in $(seq 1 16)
	do
	    var=brutecpu$i
	    eval a=\$$var
	    [ $a == on ] && bcpu="1$bcpu" || bcpu="0$bcpu"
	done
	mcpu=$(v_hex $cpu)
#	$(v_write brutecpu $mcpu)
	
	$(v_write2 "maxrate:$samplerate fixrate:yes sqpipe:standart brutecpu:$mcpu")

#restart squeezlite
	sqzlite=$(v_read sqzlite)
        sqalsa=$(v_read sqalsa)
        sqname=$(v_read squeezeplayername)
        sqcpu=$(v_read sqcpu)
        sqoutcpu=$(v_read sqoutcpu)
        sqprio=$(v_read sqprio)
    
        sqbuffer=$(v_read sqbuffer)
        sqoutbuffer=$(v_read sqoutbuffer)
        fixrate=$(v_read fixrate)
        limitrate=$(v_read limitrate)
        maxrate=$(v_read maxrate)
        bit=${maxrate%\/*}
        rate=${maxrate#*\/}
        srate=""
	[ $limitrate == yes ] && srate="-r $rate"
        [ $fixrate == yes ] && srate="-r $rate-$rate"
        usample=""
	[ $upsample == yes ] && usample="-u vLs:18:3"
    
	audiodev=$(v_read audiodev)
        [ $audiodev == usb ] && spk=front || spk=iec958
        [ $brutefir == yes ] && spk="hw:Loopback,0,0"
        cpu2=""
        [ -n "$sqcpu" ] && [ "$sqcpu" != "0x0" ] && cpu2="/usr/bin/taskset $sqcpu"
	$cpu2 $sqzlite -o $spk -a $sqalsa -b $sqbuffer:$sqoutbuffer $srate $usample -p $sqprio -z
        sleep 1.0
        a=$(/usr/bin/ps2 -C squeezelite -L | tail -1 | awk '{print $2}')
        if [ -n "$a" ]; then
            sudo /usr/bin/renice -10 $a
            sudo /usr/bin/taskset -p $sqoutcpu $a
        fi
#start brutefir
        if [ "$brutefir" == "yes" ]; then
	    br=/usr/lib/brutefir/brutefir.real
	    cpubr=""
	    [ -n "$mcpu" ] && [ "$mcpu" != "0x0" ] && cpubr="/usr/bin/taskset $mcpu"
    	    sudo $cpubr $br -nodefault $brconfig -daemon
	fi 

    else
	brutefir=no
	sudo /usr/bin/pkill brutefir.real
    fi
    $(v_write brutefir $brutefir)
fi
