#!/bin/sh
cgi_getvars()
{
    [ $# -lt 2 ] && return
    local q p k v s
# get query
    case $1 in
    	GET)
	        [ ! -z "${QUERY_STRING}" ] && q="${QUERY_STRING}&"
	        echo "${QUERY_STRING}" 
    	    ;;
    esac
    shift
    s=" $* "
    # parse the query data
    while [ ! -z "$q" ]; do
    	p="${q%%&*}"  # get first part of query string
        k="${p%%=*}"  # get the key (variable name) from it
    	v="${p#*=}"   # get the value from it
        q="${q#$p&*}" # strip first part from query string
    	
        [ "$1" = "ALL" -o "${s/ $k /}" != "$s" ] && \
	    eval "$k=$v"
    done
    return
}

echo "${QUERY_STRING}">123.txt
# register all GET variables
cgi_getvars GET ALL

sysconf(){
    a=$(cat $fname | grep "$1$2")
    if [ -n "$a" ]; then
	para="yes"
	[ $1 == "max_cstate" ] && para=0
	[ $1 == "elevator" ] && para=deadline
    else 
	para="no"
	[ $1 == "max_cstate" ] && para=1
	[ $1 == "elevator" ] && para=cfq
    fi
    echo "$1:$para;"
}

boot=$(cat /etc/sysconfig/backup_device| sed "s|\/tce||")
fname="/mnt/$boot/boot/syslinux/syslinux.cfg"

cfg=${cfg//+/}
mydesc=${mydesc//+/ }

tce=$(cat /etc/sysconfig/backup_device)
demand="/mnt/$tce/ondemand"

if [ -n "$remove" ]; then
    if [ -n "$cfg" ]; then
	/bin/rm -f $demand/$cfg.cfg
    fi
    exit
fi

if [ -n "$typ" ]; then
if [ "$typew" == "load" ]; then #loading config
# prepare
    sudo /bin/rm -f /tmp/temp.cfg
    cat $demand/$cfg.cfg | tr ';' '\n' | sed "/description/d" > /tmp/temp.cfg

#1. var.sh
    echo "" > /tmp/var.sh
    cat /tmp/temp.cfg | sed "/log_level/,$ d" | while read line
    do
        echo $line >>/tmp/var.sh
    done
    sudo /bin/mv -f /tmp/var.sh /opt/var.sh

#3. syslinux ???
    cat /tmp/temp.cfg | sed "1,/dsdusb/ d" >/tmp/temp.1
    a=$(cat /tmp/temp.1 | grep "systimer")
    val=${a#*:}
    if [ "$val" == "hpet" ]; then
	sed -e "s/tsc/hpet/" $fname > /tmp/temp.$$ && sudo /bin/mv -f /tmp/temp.$$ $fname
	sudo echo "hpet" > /sys/devices/system/clocksource/clocksource0/current_clocksource 2>>err.txt
    else
	sed -e "s/hpet/tsc/" $fname > /tmp/temp.$$ && sudo /bin/mv -f /tmp/temp.$$ $fname
	sudo echo "tsc" > /sys/devices/system/clocksource/clocksource0/current_clocksource 2>>err.txt
    fi
#-------
    a=$(cat /tmp/temp.1 | grep "elevator")
    val=${a#*:}
    if [ "$val" == "cfq" ]; then
        a=$(cat $fname | grep "=deadline")
        if [ -n "$a" ]; then
    	    sed -e "s/deadline/cfq/" $fname >/tmp/temp.$$ && sudo /bin/mv -f /tmp/temp.$$ $fname
        fi
        b=$(cat $fname | grep "cfqset")
	val=${b#*:}
	/opt/cfq.sh $cfqset

    else
        a=$(cat $fname | grep "elevator=")
        if [ -n "$a" ]; then
    	    sed -e "s/cfq/deadline/" $fname >/tmp/temp.$$ && sudo /bin/mv -f /tmp/temp.$$ $fname
    	else
    	    sed -e "s|^.*tinyrt\.gz|& elevator=deadline|" $fname >/tmp/temp.$$ && sudo /bin/mv -f /tmp/temp.$$ $fname
        fi
    fi
#-------
    a=$(cat /tmp/temp.1 | grep "cron")
    val=${a#*:}
    if [ "$val" == "yes" ]; then
        a=$(cat $fname | grep " cron")
	if [ -n "$a" ]; then
	    sed -e "s|^.*tinyrt\.gz|& cron|" $fname >/tmp/temp.$$ && sudo /bin/mv -f /tmp/temp.$$ $fname
	fi
    else
	sed -e "s/ cron//" $fname >/tmp/temp.$$ && sudo /bin/mv -f /tmp/temp.$$ $fname
    fi
#-------
    a=$(cat /tmp/temp.1 | grep "nohz")
    val=${a#*:}
    if [ "$val" == "yes" ]; then
	sed -e "s/ nohz=off//" $fname >/tmp/temp.$$ && sudo /bin/mv -f /tmp/temp.$$ $fname
    else
	a=$(cat $fname | grep " nohz")
	if [ -z "$a" ]; then
	    sed -e "s|^.*tinyrt\.gz|& nohz=off|" $fname >/tmp/temp.$$ && sudo /bin/mv -f /tmp/temp.$$ $fname
	fi
    fi
#-------
    a=$(cat /tmp/temp.1 | grep "max_cstate")
    val=${a#*:}
    if [ $val -eq 1 ]; then
	sed -e "s/cstate=0/cstate=1/" $fname >/tmp/temp.$$ && sudo /bin/mv -f /tmp/temp.$$ $fname
    else
	sed -e "s/cstate=1/cstate=0/" $fname >/tmp/temp.$$ && sudo /bin/mv -f /tmp/temp.$$ $fname
    fi

#4. asoundrc
    alsabuf=$(cat /tmp/temp.cfg | grep "alsabuffer")
    alsabuffer=${alsabuf#*:}
    alsaper=$(cat /tmp/temp.cfg | grep "alsaperiods")
    alsaperiods=${alsaper#*:}
    if [ "$alsabuffer" == "auto" ]; then
	cat /home/tc/.asoundrc | sed "s|^.*period_size.*$|#\tperiod_size \"4\"|1;s|^.*buffer_size.*$|#\tbuffer_size \"4\"|1" > /tmp/temp.10 && sudo /bin/mv -f /tmp/temp.10 /home/tc/.asoundrc 2>>err.txt
    else
	let "p=$alsabuffer / $alsaperiods"
        cat /home/tc/.asoundrc | sed "s|^.*period_size.*$|\tperiod_size \"$p\"|1;s|^.*buffer_size.*$|\tbuffer_size \"$alsabuffer\"|1" >/tmp/temp.10 && sudo /bin/mv -f /tmp/temp.10 /home/tc/.asoundrc 2>>err.txt
    fi
    
#5. alsaprio
    alsart=$(cat /tmp/temp.cfg | grep "alsart")
    alsaprio=${alsart#*:}
    bootlst=/mnt/$tce/onboot.lst
    
    if [ "$alsaprio" == "standart" ] && [ -n $(cat $bootlst | grep "Linux-PAM") ]; then
        cat $bootlst | sed /PAM/d >/tmp/temp.$$$ && sudo /bin/mv -f /tmp/temp.$$$ $bootlst
    else
        if [ -z $(cat $bootlst | grep "Linux-PAM") ]; then
	    cat $bootlst | sed "7iLinux-PAM.tcz" >/tmp/temp.$$$ && sudo /bin/mv -f /tmp/temp.$$$ $bootlst
	fi
	    
	if [ $alsaprio == high ]; then
	    aprio=90
	    anice=-10
	else
	    if [ $alsaprio == extreme ]; then
	        aprio=99
	        anice=-19
	    else # highest
	        aprio=95
	        anice=-15
	    fi
	fi
	ff1=/etc/security/limits.conf

	cat $ff1 | sed "s|^.*rtprio.*|@audio - rtprio $aprio|;s|^.*nice.*|@audio - nice $anice|" >/tmp/temp.$$$
	sudo /bin/mv -f /tmp/temp.$$$ $ff1
    fi
    echo "$cfg" > /home/tc/lastcfg
fi #load

################################################################
if [ "$typew" == "save" ]; then #save config
#1. var.sh
    str="description=$mydesc;"
    str=$str$(cat /opt/var.sh | tr '\n' ';'| sed "s/;;/;/g")

#3 syslinux.cfg

    cfgpar="=0 =deadline"
    cfglist="max_cstate elevator cron nohz"
    i=0
    for x in $cfglist
    do
        i=$(( $i + 1 ))
        a=$(echo $cfgpar|cut -d " " -f $i)
        str="$str$(sysconf $x $a)"
    done

#4. asoundrc
    alsabuf=$(cat /home/tc/.asoundrc | grep buffer_size)
    m2=$(echo $alsabuf| cut -c 1)
    if [ "$m2" == "#" ]; then
	alsabuffer=auto
    else
	alsabuf=${alsabuf%\"*}
	alsabuffer=${alsabuf#*\"}
    fi
    str=$str"alsabuffer:$alsabuffer;"

#5. alsaprio
    fl=$(cat /mnt/$tce/onboot.lst | grep "Linux-PAM")
    if [ -n "$fl" ]; then
	alsart=$(cat /etc/security/limits.conf | grep rtprio|cut -d " " -f 4)
	if [ $alsart -eq 99 ]; then
	    alsart=extreme
	else
	    if [ $alsapr -eq 95 ]; then
		alsart=highest
	    else
		alsart=high
	    fi
	fi
    else
	alsart=standart
    fi
    str=$str"alsart:$alsart;"
#    [ -f $demand/$cfg.cfg ] && sudo /bin/rm -f $demand/$cfg.cfg
    echo $str > $demand/$cfg.cfg
    echo $cfg > /home/tc/lastcfg

fi

fi