#!/bin/sh
cgi_getvars()
{
    [ $# -lt 2 ] && return
    local q p k v s
# get query
    case $1 in
    	GET)
	        [ ! -z "${QUERY_STRING}" ] && q="${QUERY_STRING}&"
	        echo "${QUERY_STRING}" 
    	    ;;
    esac
    shift
    s=" $* "
    # parse the query data
    while [ ! -z "$q" ]; do
    	p="${q%%&*}"  # get first part of query string
        k="${p%%=*}"  # get the key (variable name) from it
    	v="${p#*=}"   # get the value from it
        q="${q#$p&*}" # strip first part from query string
    	
        [ "$1" = "ALL" -o "${s/ $k /}" != "$s" ] && \
	    eval "$k=$v"
    done
    return
}

varfile=/opt/var.sh

v_hex() {
    binary=$1
    
    bnumber=$binary
    power=1
    while [ $binary -ne 0 ]
    do
    	rem=$(expr $binary % 10)
	decimal=$((decimal+(rem*power)))
        power=$((power*2))
        binary=$(expr $binary / 10)
    done

    printf '0x%x' "$decimal"
}

v_read(){
    echo $(grep "^$1=" $varfile | sed -e "s|^$1=||")
}
v_write(){
    sed -e "s/^$1=.*/$1=$2/" $varfile > /tmp/temp.$$
    sudo /bin/mv -f /tmp/temp.$$ $varfile
}

v_write2(){
    str="cat $varfile"
    for x in $1
    do
    	pre1=$(echo $x | cut -f 1 -d ':')
        pre2=$(echo $x | cut -f 2 -d ':')
        echo $pre1 $pre2
        str=$(echo "$str | sed -e 's|^$pre1=.*|$pre1=$pre2|'")
    done
    str=$(echo $str " > /tmp/temp.$$ && sudo /bin/mv -f /tmp/temp.$$ $varfile")
    eval $str
}

#echo "${QUERY_STRING}">123.txt
# register all GET variables
cgi_getvars GET ALL

if [ -n "$stweak_save" ]; then

    if [ -n "$cpufreq" ]; then
	cputop=$(cat /sys/devices/system/cpu/cpu0/cpufreq/scaling_available_frequencies|awk '{print $1}')
	if [ "$cputop" == "$cpufreq" ]; then
    	    lcpu=no
    	else
    	    lcpu=yes
	fi
	sudo /usr/local/bin/cpufreq-set -c 0 -f $cpufreq -r
    	sudo /usr/local/bin/cpufreq-set -c 1 -f $cpufreq -r
    fi

    boot=$(cat /etc/sysconfig/backup_device | sed "s|\/tce||")
    fname="/mnt/$boot/boot/syslinux/syslinux.cfg"
#---------------------------------
    if [ -n "$cron" ]; then
	a=$(cat $fname | grep " cron")
	if [ -z "$a" ]; then
	    sed -e "s|^.*tinyrt\.gz|& cron|" $fname>/tmp/temp.$$ && sudo /bin/mv -f /tmp/temp.$$ $fname
	fi
    else
	sed -e "s/ cron//" $fname>/tmp/temp.$$ && sudo /bin/mv -f /tmp/temp.$$ $fname
    fi
    if [ -n "$dynticks" ]; then
	sed -e "s/ nohz=off//" $fname>/tmp/temp.$$ && sudo /bin/mv -f /tmp/temp.$$ $fname
    else
	a=$(cat $fname | grep " nohz")
	if [ -z "$a" ]; then
	    sed -e "s|^.*tinyrt\.gz|& nohz=off|" $fname>/tmp/temp.$$ && sudo /bin/mv -f /tmp/temp.$$ $fname
	fi
    fi
    if [ -n "$autoirq" ]; then
	airq=yes
    else
	airq=no
    fi
#--------------------------------
    if [ -n "$cfqset" ]; then
	sudo /opt/cfq.sh $cfqset
    fi

    if [ $systimer == hpet ]; then
	sed -e "s/tsc/hpet/" $fname>/tmp/temp.$$ && sudo /bin/mv -f /tmp/temp.$$ $fname
#	sudo echo hpet > /sys/devices/system/clocksource/clocksource0/current_clocksource 2>>err.txt
    else
	sed -e "s/hpet/tsc/" $fname>/tmp/temp.$$ && sudo /bin/mv -f /tmp/temp.$$ $fname
#	sudo echo tsc > /sys/devices/system/clocksource/clocksource0/current_clocksource 2>>err.txt
    fi
#--------------------------------
    if [ $cstate -eq 1 ]; then
	sed -e "s/cstate=0/cstate=1/;s/cstate=3/cstate=1/" $fname>/tmp/temp.$$ && sudo /bin/mv -f /tmp/temp.$$ $fname
	sed -e "s/off=0/off=1/" $fname>/tmp/temp.$$ && sudo /bin/mv -f /tmp/temp.$$ $fname
    else 
	if [ $cstate -eq 0 ]; then
	    sed -e "s/cstate=1/cstate=0/;s/cstate=3/cstate=0/" $fname>/tmp/temp.$$ && sudo /bin/mv -f /tmp/temp.$$ $fname
	    sed -e "s/off=0/off=1/" $fname>/tmp/temp.$$ && sudo /bin/mv -f /tmp/temp.$$ $fname
	else
	    sed -e "s/cstate=1/cstate=3/;s/cstate=0/cstate=3/" $fname>/tmp/temp.$$ && sudo /bin/mv -f /tmp/temp.$$ $fname
	    sed -e "s/off=1/off=0/" $fname>/tmp/temp.$$ && sudo /bin/mv -f /tmp/temp.$$ $fname
	fi
    fi
#--------------------------------
    if [ $scheduler == cfq ]; then
	a=$(cat $fname | grep "=deadline")
	if [ -n "$a" ]; then
	    sed -e "s/deadline/cfq/" $fname>/tmp/temp.$$ && sudo /bin/mv -f /tmp/temp.$$ $fname
	fi
    else
	a=$(cat $fname | grep "elevator=")
	if [ -n "$a" ]; then
	    sed -e "s/cfq/deadline/" $fname>/tmp/temp.$$ && sudo /bin/mv -f /tmp/temp.$$ $fname
	else
	    sed -e "s|^.*tinyrt\.gz|& elevator=deadline|" $fname>/tmp/temp.$$ && sudo /bin/mv -f /tmp/temp.$$ $fname
	fi
    fi

    ncpu=$(cat /tmp/numcpu)
    kcpu=
    al=0
    if [ $cpu1 == on ]; then
	kcpu="0"
	al=1
    fi

    bcpu=
    for i in $(seq 2 16)
    do
	var=cpu$i
	eval a=\$$var
	if [ $a == on ]; then
	     kcpu="$kcpu,$(($i - 1))"
	     al=$(($al + 1))
	fi
    done

    if [[ ${kcpu:0:1} == "," ]]; then kcpu=${kcpu#,}; fi
    [ $ncpu == $al ] && kcpu=${kcpu%,*}
#    echo $kcpu >err1.txt

    sed -e "s/isolcpus=.*/isolcpus=$kcpu /" $fname >/tmp/temp.1 && sudo /bin/mv -f /tmp/temp.1 $fname

    bcpu=
    for i in $(seq 1 16)
    do
	var=lmscpu$i
	eval a=\$$var
	[ $a == on ] && bcpu="1$bcpu" || bcpu="0$bcpu"
    done

    lmscpu=$(v_hex $bcpu)

    $(v_write2 "systimer:$systimer tscfq:$tscfq hpetfq:$hpetfq autoirq:$airq lmscpu:$lmscpu")
#    $(v_write2 "systimer:$systimer tscfq:$tscfq hpetfq:$hpetfq lowcpu:$lcpu cpufreq:$cpufreq cfqset:$cfqset autoirq:$airq")

fi

