#!/bin/sh

varfile=/opt/var.sh

cgi_getvars()
{
    [ $# -lt 2 ] && return
    local q p k v s
# get query
    case $1 in
    	GET)
	        [ ! -z "${QUERY_STRING}" ] && q="${QUERY_STRING}&"
	        echo "${QUERY_STRING}" 
    	    ;;
    esac
    shift
    s=" $* "
    # parse the query data
    while [ ! -z "$q" ]; do
    	p="${q%%&*}"  # get first part of query string
        k="${p%%=*}"  # get the key (variable name) from it
    	v="${p#*=}"   # get the value from it
        q="${q#$p&*}" # strip first part from query string
    	
        [ "$1" = "ALL" -o "${s/ $k /}" != "$s" ] && \
	    eval "$k=$v"
    done
    return
}

v_read(){
    echo $(grep "^$1=" $varfile | sed -e "s|^$1=||")
}
v_write(){
    sed -e "s/^$1=.*/$1=$2/" $varfile > /tmp/temp.$$
    sudo /bin/mv -f /tmp/temp.$$ $varfile
}

v_write2(){
    str="cat $varfile"
    for x in $1
    do
	pre1=$(echo $x | cut -f 1 -d ':')
	pre2=$(echo $x | cut -f 2 -d ':')
        str=$(echo "$str | sed -e 's|^$pre1=.*|$pre1=$pre2|'")
    done
    str=$(echo $str " > /tmp/temp.$$ && sudo /bin/mv -f /tmp/temp.$$ $varfile")
    eval $str
}

#echo "${QUERY_STRING}">123.txt
# register all GET variables
cgi_getvars GET ALL

#MPC=/usr/local/bin/mpc
#echo "begin">11.txt

#-------- 1 Network
#dhcp_save
boot=$(cat /etc/sysconfig/backup_device | sed "s|\/tce||")
fname="/mnt/$boot/boot/syslinux/syslinux.cfg"
if [ -n "$dhcp_save" ]; then
    if [ -n "$ipdns1" ]; then 
	echo "nameserver $ipdns1" >/tmp/resolv.conf
	sudo /bin/mv -f /tmp/resolv.conf /etc/resolv.conf
    fi

    if [ -n "$dhcp" ]; then
	$(v_write dhcp yes)
	sed "s/nodhcp//g" $fname >/tmp/temp.$$
	sudo /bin/mv -f /tmp/temp.$$ $fname
	$(v_write2 "ipdns1:$ipdns1 ipdns2:$ipdns2")
    else
	$(v_write dhcp no)
	flag=$(cat $fname | grep "nodhcp")
	if [ -z "$flag" ]; then
	    sed -e "s|^.*tinyrt\.gz|& nodhcp|" $fname >/tmp/temp.$$
	    sudo /bin/mv -f /tmp/temp.$$ $fname
	fi

	$(v_write2 "ipaddr:$ipaddr ipbcast:$ipbcast ipgate:$ipgate ipdns1:$ipdns1 ipdns2:$ipdns2")
    fi
fi

sname="/mnt/$boot/tce/shares.txt"
# remove share
if [ -n "$net_remove" ]; then
    if [ "$oldname" != "add_new" ]; then
	sed "/\[$namedir\]/,/#/d" $sname >/tmp/temp.$$
	sudo /bin/mv -f /tmp/temp.$$ $sname

	#umount & remove
	sudo /bin/rm -f /home/tc/music/$namedir
	sudo /bin/umount /mnt/$namedir
	sudo /bin/rm -f /mnt/$namedir 
    fi
fi

if [ -n "$net_save" ]; then
    dop=""
    if [ -n "$acapsule" ]; then
	dop=",sec=ntlm"
    fi

    if [ "$oldname" == "add_new" ]; then
share=$(echo "$share" | sed 's|%2F|\/|g')
echo -e "[$namedir]
fs=$fs
server=$server
share=$share
dir=$dir1
user=$user
pass=$pass
dop=$dop
#">>$sname

	[ ! -d "/mnt/$namedir" ] && sudo /bin/mkdir /mnt/$namedir
	if [ "$fs" == "cifs" ]; then
    	    str=$(sudo /bin/mount -t cifs //$server/$share /mnt/$namedir -o user=$user,pass=$pass,iocharset=utf8$dop)
    	else
    	    str=$(sudo /sbin/mount.nfs $server:/$share /mnt/$namedir -o nolock)
    	fi
#        eval $str
        if [ -n "$dir1" ]; then
	    /bin/ln -s /mnt/$namedir/$dir1 /home/tc/music/$namedir
	else	
	    /bin/ln -s /mnt/$namedir /home/tc/music/$namedir
	fi
        /usr/local/bin/mpc update $namedir
    else
	#change settings
	share1=$share
	share=$(echo "$share" | sed 's|%2F|\/|g')
#	dir1=$(echo "$dir1" | sed 's|%2F|\/|g')

	pshare=$(echo "$share1" | sed 's|%2F|\\\/|g')
#	pdir1=$(echo "$dir1" | sed 's|%2F|\\\/|g')

	if [ -n "$namedir" ]; then
	    if [ ! "$oldname" == "$namedir" ] && [ -n "$oldname" ]; then #change section name
		sed -e "s/\[$oldname/\[$namedir/" $sname >/tmp/temp.$$
		sudo /bin/mv -f /tmp/temp.$$ $sname
	    fi
	
	    #update_ini
	
	    sed "/^\[$namedir\]$/,/#/s/^server=.*/server=$server/;/^\[$namedir\]$/,/#/s/^share=.*/share=$pshare/" $sname >/tmp/temp.$$
	    sudo /bin/mv -f /tmp/temp.$$ $sname
	    sed "/^\[$namedir\]$/,/#/s/^dir=.*/dir=$dir1/;/^\[$namedir\]$/,/#/s/^user=.*/user=$user/;/^\[$namedir\]$/,/#/s/^pass=.*/pass=$pass/" $sname >/tmp/temp.$$
	    sudo /bin/mv -f /tmp/temp.$$ $sname
	    sed "/^\[$namedir\]$/,/#/s/^dop=.*/dop=$dop/" $sname >/tmp/temp.$$
	    sudo /bin/mv -f /tmp/temp.$$ $sname

	    sudo /bin/rm -f /home/tc/music/$oldname
	    sudo /bin/umount /mnt/$oldname
	    sudo /bin/rm -f /mnt/$oldname
	    sudo /bin/mkdir /mnt/$namedir
	fi
    fi
    # mounting
    if [ -n "$namedir" ]; then
	if [ "$fs" == "cifs" ]; then
	    str=$(sudo /bin/mount -t cifs //$server/$share /mnt/$namedir -o user=$user,pass=$pass,iocharset=utf8$dop)
	else
    	    str=$(sudo /sbin/mount.nfs $server:/$share /mnt/$namedir -o nolock 2>>err.txt)
	fi
#	eval $str
        if [ -n "$dir1" ]; then
	    /bin/ln -s /mnt/$namedir/$dir1 /home/tc/music/$namedir
	else	
	    /bin/ln -s /mnt/$namedir /home/tc/music/$namedir
	fi
	/usr/local/bin/mpc update $namedir
    fi
fi

#echo "end">>11.txt