#!/bin/sh
cgi_getvars()
{
    [ $# -lt 2 ] && return
    local q p k v s
# get query
    case $1 in
    	GET)
	        [ ! -z "${QUERY_STRING}" ] && q="${QUERY_STRING}&"
	        echo "${QUERY_STRING}" 
    	    ;;
    esac
    shift
    s=" $* "
    # parse the query data
    while [ ! -z "$q" ]; do
    	p="${q%%&*}"  # get first part of query string
        k="${p%%=*}"  # get the key (variable name) from it
    	v="${p#*=}"   # get the value from it
        q="${q#$p&*}" # strip first part from query string
    	
        [ "$1" = "ALL" -o "${s/ $k /}" != "$s" ] && \
	    eval "$k=$v"
    done
    return
}

varfile=/opt/var.sh

v_write(){
    sed -e "s/^$1=.*/$1=$2/" $varfile >/tmp/temp.$$ 
    sudo /bin/mv -f /tmp/temp.$$ $varfile
}

#echo "${QUERY_STRING}">123.txt
# register all GET variables
cgi_getvars GET ALL

if [ -n "$role" ]; then
    boot=$(cat /etc/sysconfig/backup_device)
    fname="/mnt/$boot/onboot.lst"
    sname="/opt/.filetool.lst"
	
    $(v_write role $role)
	
    if [ $role == full ] || [ $role == server ]; then
        if [ -z $(cat $fname | grep lms79) ]; then
	    cat $fname | sed "10ilms79.tcz" | sed "10iperl5.tcz" | sed "10ilibjpeg-turbo.tcz" >/tmp/tmp.$$$
	    sudo /bin/mv -f /tmp/tmp.$$$ $fname
	fi
	if [ -z $(cat $sname | grep lms) ]; then
	    echo "/usr/lms/prefs" >> $sname
	    echo "/usr/lms/Cache" >> $sname
	fi
    else
	if [ -n $(cat $fname | grep "lms79") ]; then
	    cat $fname | sed /lms79/d | sed /perl5/d | sed /libjpeg/d >/tmp/tmp.$$$
	    sudo /bin/mv -f /tmp/tmp.$$$ $fname

	    cat $sname | sed /lms/d  >/tmp/tmp.$$$
	    sudo /bin/mv -f /tmp/tmp.$$$ $sname
	fi
    fi
fi

if [ -n "$mysq" ]; then
    $(v_write mysqueezebox $mysq)
fi

if [ -n "$upnp" ]; then
    $(v_write lmsupnp $upnp)
fi

if [ -n "$convert" ]; then
    $(v_write srvconvert $convert)
fi
