#!/bin/sh
cgi_getvars()
{
    [ $# -lt 2 ] && return
    local q p k v s
# get query
    case $1 in
    	GET)
	        [ ! -z "${QUERY_STRING}" ] && q="${QUERY_STRING}&"
	        echo "${QUERY_STRING}" 
    	    ;;
    esac
    shift
    s=" $* "
    # parse the query data
    while [ ! -z "$q" ]; do
    	p="${q%%&*}"  # get first part of query string
        k="${p%%=*}"  # get the key (variable name) from it
    	v="${p#*=}"   # get the value from it
        q="${q#$p&*}" # strip first part from query string
    	
        [ "$1" = "ALL" -o "${s/ $k /}" != "$s" ] && \
	    eval "$k=$v"
    done
    return
}

varfile=/opt/var.sh
v_read(){
    echo $(grep "^$1=" $varfile | sed -e "s|^$1=||")
}
v_write(){
    sed -e "s/^$1=.*/$1=$2/" $varfile >/tmp/temp.$$ 
    sudo /bin/mv -f /tmp/temp.$$ $varfile
}

#echo "${QUERY_STRING}">123.txt
# register all GET variables
cgi_getvars GET ALL

MPC=/usr/local/bin/mpc

ncpu=$(cat /tmp/numcpu)
boot=$(cat /etc/sysconfig/backup_device)
fname="/mnt/$boot/onboot.lst"

if [ $ncpu -ne 1 ];  then
    cpu1=""
else
    if [ $ncpu -ne 2 ];  then
	cpu1="/usr/bin/taskset 0x00000001"
    else
	cpu1="/usr/bin/taskset 0x00000006"
    fi
fi
#-------- 1 Network
if [ $command == poweroff ]; then
    if [ -f /tmp/action ]; then
	exit 0
    fi
    echo "poweroff">/tmp/action
#    sudo /bin/rm -f /opt/www/cgi-bin/*.txt
    sudo /bin/rm -f /home/tc/log/*.*
    if [ -n "$(/bin/pidof mpd)" ]; then
	stop=$(v_read mpdstop)
	if [ $stop == yes ]; then
	    $MPC stop
	fi
	sudo /usr/bin/pkill mpd
    fi
    $(/opt/backup.sh)
    echo "poweroff">>err.txt
    $(sudo /sbin/poweroff)
fi
if [ $command == reboot ]; then
    if [ -f /tmp/action ]; then
	exit 0
    fi
    echo "reboot">/tmp/action
    if [ -n "$(/bin/pidof mpd)" ]; then
	stop=$(v_read mpdstop)
	if [ $stop == yes ]; then
	    $MPC stop
	fi
    fi
    $(/opt/backup.sh)
    $(sudo /sbin/reboot)
fi

if [ $command == changelang ]; then
    tce=$(cat /etc/sysconfig/backup_device)
    echo $lang > /mnt/$tce/language/default
fi

if [ -n "$ssh_save" ]; then
    if [ -n "$sshsrv" ]; then
	$(v_write sshserv yes)
	if [ -z $(/bin/pidof dropbear) ]; then
	    sudo $cpu1 /etc/init.d/dropbear start
	fi
    else
	$(v_write sshserv no)
	sudo /etc/init.d/dropbear stop
    fi

    if [ -n "$samba" ]; then
	$(v_write samba yes)
	if [ -z $(cat $fname | grep samba3) ]; then
	    cat $fname | sed "20isamba3.tcz" >/tmp/temp.$$
	    sudo /bin/mv -f /tmp/temp.$$ $fname
	fi
	if [ -z $(/bin/pidof smbd) ]; then
	    /usr/bin/tce-load -i samba3
	    sudo $cpu1 /usr/local/etc/init.d/samba start
	fi
    else
	$(v_write samba no)
	if [ -n $(cat $fname|grep samba3) ]; then
	    cat $fname|sed /samba3/d >/tmp/temp.$$
	    sudo /bin/mv -f /tmp/temp.$$ $fname
	fi
	sudo /usr/local/etc/init.d/samba stop
    fi
    
fi