#!/bin/sh

tce=$(cat /etc/sysconfig/backup_device)
lang=$(cat /mnt/$tce/language/default)
[ "$lang" == "" ] && lang=ru
source /opt/var.sh
source /mnt/$tce/language/lang_$lang

cpu=$(grep -c processor /proc/cpuinfo)
cols=$(($cpu + 3))
pred=$(($cpu + 2))

cat <<EOF
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">

<head>
<meta content="yes" name="apple-mobile-web-app-capable" />
<meta content="text/html; charset=utf-8" http-equiv="Content-Type" />
<meta content="minimum-scale=1.0, width=device-width, maximum-scale=0.6667, user-scalable=no" name="viewport" />
<link href="css/style.css" rel="stylesheet" media="screen" type="text/css" />
<script src="js/functions.js" type="text/javascript"></script>
<title>TinySqueeze - irq priority</title>
</head>

<body>
<script>
    function reload_page(){
	setInterval('location.reload()',1000);
    }
</script>
<div id="topbar">
	<div id="leftnav">
		<a href="kernel.yy"><img src="images/home.png" /></a></div>
	<div id="title">$mnu3_s29</div>
</div>
<style>
table {
border-spacing:0px;
}
tr td{
border-top:1px dotted #bbb;
padding:2px 5px 2px 7px;
}
//tr:nth-child(odd) {background:#dddee0}
</style>
<div id="content">
	<ul class="pageitem">
	    <li class="textbox"><p>$mnu7_desc</p></li>
	    <li class="textbox">
		<form name="ssh" action="http://${HTTP_HOST}/cgi-bin/submit_irq.yy" target="myIFR" method="GET">
	<table style="margin:10px;">
EOF
prios="- 55 60 65 70 75 80 85 90 95"
num=0
    cat /proc/interrupts | while read col1 col2 col3 col4 col5 col6 col7
    do
	if [ $num == 0 ]; then
	    col5=$col4
	    col4=$col3
	    col3=$col2
	    col2=$col1
	    col1=IRQ
	    td=th
	else
	    td=td
	fi
	irq=${col1/:/}
	if [ $irq -eq $irq 2> /dev/null ] || [ $num == 0 ] ; then
	    echo "<tr>"
	    for i in `seq 1 $cols`
	    do
	    	if [ $i != $pred ]; then
		    var=col$i
		    echo "<$td> $(eval echo -n \"\$$var\")</$td>"
		fi
	    done
	if [ $num == 0 ]; then
	    echo "<th>Prio</th>"
	    echo "<th>Set</th>"
	else
	    prio=$(ps2 -eo pid,rtprio,cmd|grep "irq/$irq-" | awk '{print $2}'| grep -v "-")
	    echo "<td>$prio</td>"
	    echo "<td><select name='irq$irq'>"
	    for j in $prios
	    do
		check=
		for k in $irqprio
		do
		    kk=${k%:*}
		    k2=${k#*:}
#		    echo "$k $kk">>2.txt
		    if [ $kk == $irq ] && [ $k2 == $j ]; then
		        check=selected
		        break
		    fi
#		    echo $k >>3.txt
		done
		echo "<option value='$j' $check>$j</option>"
	    done
	    echo "</select><span class='arrow'></span></td>"
	fi
	    echo "</tr>"
	fi
	num=$(($num + 1))
    done
cat <<EOF
	</table>
	<li class="button">
	<input name="updateirq" type="submit" value="$mnu_apply" onclick='reload_page();' />
	</li>
		</form>
	</ul>

</div>
<iframe name="myIFR" style="display: none"></iframe>
EOF
echo "</body>"
echo "</html>"
