#!/bin/sh

tce=$(cat /etc/sysconfig/backup_device)
lang=$(cat /mnt/$tce/language/default)

[ "$lang" == "" ] && lang=ru

source /opt/var.sh
source /mnt/$tce/language/lang_$lang

ncpu=$(cat /tmp/numcpu)

v_bin() {
    decnum=$(printf "%d" $1)
    binary=
    number=$decnum

    while [ $decnum -ne 0 ]
    do
    	bit=$(expr $decnum % 2)
        binary=$bit$binary
    	decnum=$(expr $decnum / 2)
    done
    len=${#binary}
    while [ $len -ne 9 ]
    do
    	binary="0$binary"
	len=${#binary}
    done
    echo $binary
}

cat <<EOF
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">

<head>
<meta content="yes" name="apple-mobile-web-app-capable" />
<meta content="text/html; charset=utf-8" http-equiv="Content-Type" />
<meta content="minimum-scale=1.0, width=device-width, maximum-scale=0.6667, user-scalable=no" name="viewport" />
<link href="css/style.css" rel="stylesheet" media="screen" type="text/css" />
<script src="js/functions.js" type="text/javascript"></script>
<title>TinySqueeze - $mnu3_desc</title>
</head>

<body>
<script>
    function irqpage() {
	location.href='irqprio.yy';
    }
    
    function hidecfq(a) {
	var obj=document.getElementById("cfqsets");
	if (a=='deadline') {
	    obj.style.display = "none";
	}
	else {
	    obj.style.display = "none"; //block
	}
	
    }
    
</script>
<div id="topbar">
	<div id="leftnav">
		<a href="index.yy"><img src="images/home.png" /></a></div>
	<div id="title">$mnu3_desc</div>
</div>

<style>
.bbox {
    min-width:380px;
    max-width:500px;
    margin:auto;
}
</style>

	<div class="bbox">
	<ul class="pageitem">
		<form action="http://${HTTP_HOST}/cgi-bin/submit_kernel.yy" target="myIFR" method="GET">
		
		<li class="select"><select name="systimer">
EOF

tlist=$(cat /sys/devices/system/clocksource/clocksource0/available_clocksource)
curtimer=$(cat /sys/devices/system/clocksource/clocksource0/current_clocksource)

for x in $tlist
do
    tcheck=""
    if [ "$x" == "$curtimer" ]; then
	tcheck=selected
    fi
    x2=$(echo $x |tr 'a-z' 'A-Z')
cat <<EOF
		<option $tcheck value="$x">Timer: $x2</option>
EOF
done


t1list="1024 2048 3072"
t2list="1024 2048 3072 4096 8192 32768"

cat <<EOF
	</select><span class="arrow"></span>
	</li>
	<li class="textbox" style="display:none;">$mnu3_s22 TSC</li>
	<li class="select"><select name="tscfq">
EOF

for x in $t1list
do
    tsel=""
    [ $x == $tscfq ] && tsel=selected
    if [ $x == 1024 ]; then
		x2="$x (default)"
	else
		x2=$x
	fi
cat <<EOF
		<option $tsel value=$x>TSC: $x2</option>
EOF
done

cat <<EOF	
	</select><span class="arrow"></span>
	</li>

	<li class="textbox" style="display:none;">$mnu3_s22 HPET</li>
	<li class="select"><select name="hpetfq">
EOF

for x in $t2list
do
    tsel=""
    [ $x == $hpetfq ] && tsel=selected
    if [ $x == 1024 ]; then
		x2="$x (default)"
	else
		x2=$x
	fi
echo "<option $tsel value=$x>HPET: $x2</option>"
done

echo "</select><span class="arrow"></span></li>"

t1=""
t2=""

boot=$(cat /etc/sysconfig/backup_device | sed "s|\/tce||")
fname=/mnt/$boot/boot/syslinux/syslinux.cfg
a=$(cat $fname |grep "=deadline")

if [ -n "$a" ]; then
    t2=selected
    cfqvis=none
else
    t1=selected
    cfqvis=block
fi

if [ -n "$cpulist" ]; then
cat <<EOF
		<li class="textbox"><p>$mnu3_s24</p></li>
		<li class="select"><select name=cpufreq>$x</span>
EOF

for x in $cpulist
do
    tcheck=""
    [ "$x" == "$curfreq" ] && tcheck=selected
    echo "<option $tcheck value="$x">$x Hz</option>"
done
fi

ct1=""
ct2=""
ct3=""
if [ -n "$(cat $fname |grep "max_cstate=1")" ]; then
    ct2=selected
else
    if [ -n "$(cat $fname |grep "max_cstate=0")" ]; then
	ct1=selected
    else
	ct3=selected
    fi
fi

a=$(cat $fname |grep " nohz")
nohz=""
[ -z "$a" ] && nohz=checked

cat <<EOF
		</select><span class="arrow"></span>
		</li>
		<li class="select"><select name="cstate">
		    <option $ct1 value="0">CPU max CState: 0</option>
		    <option $ct2 value="1">CPU max CState: 1</option>
		    <option $ct3 value="disabled">CPU max CState: disabled</option>
		</li>
		</select><span class="arrow"></span>
		<li class="checkbox"><span class="name">$mnu3_s28</span>
		<input name="dynticks" type="checkbox" $nohz /> </li>
		<li class="textbox" style="display:none;">$mnu3_s23</li>
		<li class="select"><select name="scheduler" onchange="hidecfq(this.value);">
		    <option $t1 value="cfq">$mnu3_s23: CFQ</option>
		    <option $t2 value="deadline">$mnu3_s23: Deadline</option> 
		</select><span class="arrow"></span>
		</li>
		<div id="cfqsets" style="display:$cfqvis">
		<li class="textbox">$mnu3_s25 CFQ</li>
		<li class="select"><select name="cfqset">
EOF
cfqlist="0 1 3 6 9"
cfqdesc="- 500/250/0 1000/100/25 100/100/50 400/200/100"

i=1
for x in $cfqlist
do
    tcheck=""
    [ "$x" == "$cfqset" ] && tcheck=selected
    if [ $x == 0 ]; then
	x1="No tweak"
    else
	desc=$(echo $cfqdesc | cut -d ' ' -f$i)
	x1="$mnu3_s26 $x ($desc)"
    fi
    i=$(( $i + 1 ))
    echo "<option $tcheck value="$x">$x1 </option>"
done

boot=$(cat /etc/sysconfig/backup_device | sed "s|\/tce||")
fname=/mnt/$boot/boot/syslinux/syslinux.cfg

a=$(cat $fname |grep " cron")
[ -n "$a" ] && cron=checked

airq=""
[ $autoirq == yes ] && airq=checked

cat <<EOF
		</select><span class="arrow"></span>
		</li>
		</div>
		<li class="checkbox"><span class="name">$mnu3_s27</span>
		<input name="cron" type="checkbox" $cron /> </li>
EOF

if [ $ncpu -gt 1 ]; then

    a=$(cat $fname |grep "isolcpus")
    if [ -n "$a" ]; then
	a=${a#*isolcpus=}
	a=${a%% *}
	a=${a//,/ }
    fi
cat <<EOF
	<li class="textbox"><b>Isolate CPU</b>
	<div style="float:right">
EOF
    x=0
    while [ $ncpu -gt $x ]; do
	tsel=
	[ -n "$(echo $a | grep $x)" ] && tsel=checked
	let "x=x+1"

	echo "<div style=\"float:left;\"><span style=\"margin-left:5px;\">$x</span><br>"
	echo "<input type=\"checkbox\" id=\"cpu$x\" name=\"cpu$x\" $tsel style=\"-webkit-appearance:checkbox;width:27px;float:left;\"></div>"
    done
    echo "</div></li>"
    if [ $role == full ] || [ $role == server ]; then
cat <<EOF 
	<li class="textbox"><b>LMS bind to CPU</b>
	<div style="float:right">
EOF
    bcpu=$(v_bin $lmscpu)
    i=$((${#bcpu} - 1))
    x=0 
    while [ $ncpu -gt $x ]; do
	let "x=x+1"
	tsel=
	a=${bcpu:$i:1}
	[ $a = 1 ] && tsel=checked
	echo "<div style=\"float:left\"><span style=\"margin-left:5px;\">$x</span><br>"
	echo "<input type=\"checkbox\" name=\"lmscpu$x\" id=\"lmscpu$x\" style=\"-webkit-appearance:checkbox; width:27px;float:left;\" $tsel></div>"
	let "i=i-1"
    done
    echo "</div></li>"
    fi
fi

cat <<EOF
		<li class="checkbox"><span class="name">$mnu3_s30</span>
		<input name="autoirq" type="checkbox" $airq /> </li>
		<li class="button">
		<input name="irqtable" type="submit" value="$mnu3_s29" onclick="irqpage();" /></li>
		<li class="button">
		<input name="stweak_save" type="submit" value="$mnu_apply" /></li>
		</form>
	</ul>
	</div>
</div>
<iframe name="myIFR" style="display: none"></iframe>
EOF
echo "</body>"
echo "</html>"