#!/bin/sh

tce=$(cat /etc/sysconfig/backup_device)
lang=$(cat /mnt/$tce/language/default)

[ "$lang" == "" ] && lang=ru

source /mnt/$tce/language/lang_$lang
source /opt/var.sh

boot=$(cat /etc/sysconfig/backup_device)
sname="/mnt/$boot/shares.txt"
shares=$(cat $sname | grep "^\[" | sed "s/\[//g;s/\]//g")
tfile=/tmp/network.txt

get_ini(){
    while read section; do
	if [ "$section" = '['$1']' ]; then
	IFS='='
	while read key value; do
	    if [ $key = $2 ]; then
		echo $value
		exit 1
	    fi
	done
	fi
    done <$sname
}

echo -e "<html>
<head>
<meta content='yes' name='apple-mobile-web-app-capable' />
<meta content='text/html; charset=utf-8' http-equiv='Content-Type' />
<meta content='minimum-scale=1.0, width=device-width, maximum-scale=0.6667, user-scalable=no' name='viewport' />
<link href='css/style.css' rel='stylesheet' media='screen' type='text/css' />
<script src='js/functions.js' type='text/javascript'></script>
<title>TinySqueeze - $mnu1_desc</title>
</head>

<body>
<script>" > $tfile

if [ -n "$shares" ]; then
    echo "var shares=[" >>$tfile
    for x in $shares; do
	s0=$(get_ini $x fs)
	s1=$(get_ini $x server)
	s2=$(get_ini $x share)
	s3=$(get_ini $x dir)
	s4=$(get_ini $x user)
	s5=$(get_ini $x pass)
	s6=$(get_ini $x dop)
	echo "['$x','$s0','$s1','$s2','$s3','$s4','$s5','$s6'],">>$tfile
    done
    echo "];">>$tfile
else
    echo "var shares=[aaa];">>$tfile
fi
echo -e "
	function fillf(par){
	    if (par==-1){
		netform.fs.selectedIndex=0;
		netform.namedir.value='';
		netform.server.value='';
		netform.share.value='';
		netform.dir1.value='';
		netform.user.value='';
		netform.pass.value='';
		
		netform.oldname.value='add_new';
	    }
	    else {
		if ( shares[par][1] == 'cifs' ) {
		    netform.fs.selectedIndex=0;
		}
		else {
		    netform.fs.selectedIndex=1;
		}
		netform.namedir.value=shares[par][0];
		netform.server.value=shares[par][2];
		netform.share.value=shares[par][3];
		netform.dir1.value=shares[par][4];
		netform.user.value=shares[par][5];
		netform.pass.value=shares[par][6];
		if ( shares[par][7] =='') {
		    netform.acapsule.checked=false;
		}
		else {
		    netform.acapsule.checked=true;
		}
		netform.oldname.value=shares[par][0];
	    }
	    cont=document.getElementById('content');
	    cont.style.display='none';
	    pop=document.getElementById('pop1');
	    pop.style.display='block';
	}
	
	function reload_page(){
	    setInterval('location.reload()',500);
	}
</script>
<div id='topbar'>
	<div id='leftnav'>
		<a href='index.yy'><img alt='home' src='images/home.png' /></a>
		</div>
	<div id='title'>$mnu1_desc</div>
	
</div>
<div id='content' style='max-width:500px;margin:auto;'>
	<ul class='pageitem'>
">>$tfile

check=""
dis=""
if [ $dhcp == yes ]; then
    check=checked
    dis=disabled
fi

echo -e "	
        <script>
        function ch_dhcp(){
	    form1.ipaddr.disabled = form1.dhcp.checked;
	    form1.ipbcast.disabled = form1.dhcp.checked;
	    form1.ipgate.disabled = form1.dhcp.checked;
        }
        </script>
	<form name='form1' action='http://${HTTP_HOST}/cgi-bin/submit_network.yy' target='myIFR' method='GET'>
		<li class='checkbox'><span class='name'>$mnu1_s1</span>
		<input name='dhcp' type='checkbox' value=$dhcp $check onchange='ch_dhcp();' /> </li>
		<li class='smallfield'><span class='name'>$mnu1_s2</span><input name='ipaddr' placeholder='$mnu1_s2e' type='text' value=$ipaddr $dis />
		</li>
		<li class='smallfield'><span class='name'>$mnu1_s3</span><input name='ipbcast' placeholder='$mnu1_s3e' type='text' value=$ipbcast $dis />
		</li>
		<li class='smallfield'><span class='name'>$mnu1_s4</span><input name='ipgate' placeholder='$mnu1_s4e' type='text' value=$ipgate $dis />
		</li>
		<li class='smallfield'><span class='name'>DNS Server 1</span><input name='ipdns1' placeholder='ex., 8.8.8.8' type='text' value='$ipdns1' />
		</li>
		<li class='smallfield'><span class='name'>DNS Server 2</span><input name='ipdns2' placeholder='ex., 8.8.8.8' type='text' value='$ipdns2' />
		</li>
		<li class='button'>
		<input name='dhcp_save' type='submit' value='$mnu_apply' /></li>
	</form>
	</ul>
	<span class='graytitle'>$mnu_sect2</span>
	<ul class='pageitem'>
	<li class='menu'><a class='noeffect' onclick='fillf(-1);'><span class='name'>$mnu1_but</span></a></li>
	">>$tfile
if [ -n "$shares" ]; then
    count=0
    for x in $shares
    do
	aa=$(mount | grep "$x" | grep -v "nfs-utils")
	img=check
	if [ -z "$aa" ]; then
	    img=denied
	fi
	echo "<li class='menu'><a class='noeffect' onclick='fillf($count);'>
		<img alt='$img' src='images/$img.png' />
		<span class='name'>$x</span>
		<span class='arrow'></span></a></li>">>$tfile
	count=$(( $count + 1 ))
    done
fi
echo -e "
	</ul>

</div>

<div id='pop1' style='display:none;max-width:500px;margin:auto;'>
<span class='graytitle'>$mnu1_ndesc</span>
	<ul class='pageitem'>

	<form name='netform' action='http://${HTTP_HOST}/cgi-bin/submit_network.yy' target='myIFR' method='GET'>
		<li class='smallfield'><span class='name'>$mnu1_n1</span>
		    <input name='namedir' placeholder='$mnu1_n1e' type='text' value='' />
		</li>
		<li class='textbox'><p>$mnu1_n2</p></li>
		<li class='select'><select name='fs' id='fs'>
		    <option value='cifs'>CIFS/SAMBA</option>
		    <option value='nfs'>NFS</option>
		</select><span class='arrow'></span></li>
		<li class='smallfield'><span class='name'>$mnu1_n3</span>
		    <input name='server' placeholder='$mnu1_n3e' type='text' value='' />
		</li>
		<li class='smallfield'><span class='name'>$mnu1_n4</span>
		    <input name='share' placeholder='$mnu1_n4e' type='text' value=''/>
		</li>
		<li class='smallfield'><span class='name'>$mnu1_n5</span>
		    <input name='dir1' placeholder='$mnu1_n5e' type='text' value=''/>
		</li>
		<li class='smallfield'><span class='name'>$mnu1_n6</span>
		    <input name='user' placeholder='$mnu1_n6e' type='text' value='' />
		</li>
		<li class='smallfield'><span class='name'>$mnu1_n7</span>
		    <input name='pass' placeholder='$mnu1_n7e' type='text' value='' />
		</li>
		<li class='smallfield' style='display:none'>
		    <input name='oldname' type='text' value='' />
		</li>
		<li class='checkbox'><span class='name'>Apple TimeCapsule</span>
		    <input name='acapsule' type='checkbox' />
		</li>
		<li class='button'>
		<input name='net_save' type='submit' value='$mnu1_nbut1' onclick='reload_page();' /></li>
		<li class='button'>
		<input name='net_remove' type='submit' value='$mnu1_nbut2' onclick='reload_page();' /></li>
		</form>
	</ul>
</div>
<iframe name='myIFR' style='display: none;'></iframe>
</body>
</html>">>$tfile

cat $tfile